<?php
/*  ------------------------------------------------------------------------
    awzMB Guestbook/Weblog System
    
    Homepage: http://www.awzhome.de/
    ------------------------------------------------------------------------
    
    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

    The Initial Developer of the Original Code is Andreas Weizel.
    Portions created by the Initial Developer are
    Copyright (C) 2001-2006 Andreas Weizel. All Rights Reserved.
    
    Contributor(s):
      Andreas Weizel <webmaster@awzhome.de> (original author)
    
    Alternatively, the contents of this file may be used under the terms
    of the GNU General Public License Version 2.0 or later (the "GPL"),
    or the GNU Lesser General Public License Version 2.1 or later (the
    "LGPL"), in which case the provisions of the GPL or the LGPL are
    applicable instead of those above. If you wish to allow use of your
    version of this file only under the terms of the GPL or the LGPL and
    not to allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and replace
    them with the notice and other provisions required by the GPL or the
    LGPL. If you do not delete the provisions above, a recipient may use
    your version of this file under the terms of any of the MPL, the GPL
    or the LGPL.
    ------------------------------------------------------------------------
*/

if (!isset($Setting['OPT_includepath'])) $Setting['OPT_includepath'] = '';

header('Content-Type: text/css');

include_once($Setting['OPT_includepath'].'awzmb/modules/core/core.incl.php');

$issample = false;
if ($_SERVER['QUERY_STRING'] == '{sample}') {
  $issample = true;
  $CurrentUser == new AMBUser();
  $CurrentUser->BackgroundPic = '';
  $CurrentUser->BackgroundColor = '#ffffff';
  $CurrentUser->TextColor = '#000000';
  $CurrentUser->LinkColor = '#0000ff';
  $CurrentUser->GBTitleColor = '#000080';
  $CurrentUser->EntryHead = '#d0e0f9';
  $CurrentUser->EntryBody = '#e0f0ff';
}

if ($CurrentUser || AMB_ReadUserInfo($_SERVER['QUERY_STRING'], true)) {
  echo('/* Grundeinstellungen fr die Gesamtseite (Schriftart, Schrift- und Hintergrundfarbe) */
  body {
    font-family: "Times New Roman",Times,serif;
    color: '.$CurrentUser->TextColor.';
    background-color: '.$CurrentUser->BackgroundColor.($CurrentUser->BackgroundPic != '' ? ';
    background-image: url('.$CurrentUser->BackgroundPic.')' : '').';
  }
  
  #AMBOutput img {
    border-style: none;
  }
  
  .EssWarning {
    color: #ff0000;
  }
  
  /* Wichtig fr die korrekte zentrierte Ausrichtung der Texte */
  #AMBOutput {
    text-align: center;
  }
  #AMBOutput table {
    text-align: left;
    margin-left: auto;
    margin-right: auto;
  }
  
  /* Einstellungen fr die Seitenberschrift */
  h1#GBTitle {
    color: '.$CurrentUser->GBTitleColor.';
    text-decoration: underline;
  }
  
  /* Textfelder im oberen Eingabeformular */
  input.TextBoxClass, #AMBOutput textarea {
    background-color: '.$CurrentUser->BackgroundColor.';
    color: '.$CurrentUser->TextColor.';
  }
  '.($issample ? '
  /* Schaltflchen im oberen Eingabeformular ("Eintragen" und "Zurcksetzen") */
  /* Wenn bentigt, folgende Zeile bitte entkommentieren und gewnschte Style-Anweisungen einfgen */
  /* input.ButtonClass {...} */
  ' : '').
  '
  /* Farbe der Links in der Seite */
  #AMBOutput a:link {color: '.$CurrentUser->LinkColor.';}     /* normaler Zustand */
  #AMBOutput a:visited {color: '.$CurrentUser->LinkColor.';}  /* bereits besuchter Link */
  #AMBOutput a:active {color: '.$CurrentUser->LinkColor.';}   /* aktiver Link */
  #AMBOutput a:hover {color: '.$CurrentUser->LinkColor.';}    /* Link beim "berfliegen" des Mauszeigers */
  
  /* Einstellungen fr den Kopf eines Eintrags (mit Name, E-Mail, Homepage, Datum...) */
  .EntryHeadClass {
    background-color: '.$CurrentUser->EntryHead.';
    color: '.$CurrentUser->TextColor.';
  }
  
  /* Dasselbe wie gerade, nur fr den Kopf von Kommentaren */
  .EntryComHeadClass {
    background-color: '.$CurrentUser->EntryBody.';
    color: '.$CurrentUser->TextColor.';
  }
  
  /* Einstellungen fr das Thema eines Eintrags */
  .EntryTopicClass {
    background-color: '.$CurrentUser->EntryHead.';
    color: '.$CurrentUser->TextColor.';
    font-style: italic;
  }
  
  /* Einstellungen fr den Eintragstext und den Webmaster-Kommentar */
  .EntryContentsClass {
    background-color: '.$CurrentUser->EntryBody.';
    color: '.$CurrentUser->TextColor.';
  }
  
  /* Navigationsleiste am Seitenende (mit den "vor"- und "zurck"-Links) */
  .NavBarClass {
    background-color: '.$CurrentUser->BackgroundColor.';
    color: '.$CurrentUser->TextColor.';
  }
  ');
}
AMB_mysql_close();
?>