<?php
/*  ------------------------------------------------------------------------
    awzMB Guestbook/Weblog System
    
    Homepage: http://www.awzhome.de/
    ------------------------------------------------------------------------
    
    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

    The Initial Developer of the Original Code is Andreas Weizel.
    Portions created by the Initial Developer are
    Copyright (C) 2001-2007 Andreas Weizel. All Rights Reserved.
    
    Contributor(s):
      Andreas Weizel <webmaster@awzhome.de> (original author)
    
    Alternatively, the contents of this file may be used under the terms
    of the GNU General Public License Version 2.0 or later (the "GPL"),
    or the GNU Lesser General Public License Version 2.1 or later (the
    "LGPL"), in which case the provisions of the GPL or the LGPL are
    applicable instead of those above. If you wish to allow use of your
    version of this file only under the terms of the GPL or the LGPL and
    not to allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and replace
    them with the notice and other provisions required by the GPL or the
    LGPL. If you do not delete the provisions above, a recipient may use
    your version of this file under the terms of any of the MPL, the GPL
    or the LGPL.
    ------------------------------------------------------------------------
*/

global $Setting;

if (!isset($Setting['OPT_includepath'])) $Setting['OPT_includepath'] = '';

include_once($Setting['OPT_includepath'].'awzmb/modules/core/core.incl.php');
include_once($Setting['OPT_includepath'].'awzmb/modules/core/session.incl.php');

AMB_SetLangResource('gbook');
AMB_SetLangResource('admin');

$infolinesclassHTML = " class=\"InfoLinesClass\"";
$entryheadclassHTML = " class=\"EntryHeadClass\"";
$entrytopicclassHTML = " class=\"EntryTopicClass\"";
$entrycontentsclassHTML = " class=\"EntryContentsClass\"";
$navbarclassHTML = " class=\"NavBarClass\"";


function showformhead($page, $action) {
  global $GlobArr;
  echo("<form action=\"".AMB_GetMyScript()."\" method=\"post\">\n");
	echo("<input type=\"hidden\" name=\"".session_name()."\" value=\"".session_id()."\" />\n");
  echo("<input type=\"hidden\" name=\"page\" value=\"$page\" />\n");
	echo("<input type=\"hidden\" name=\"action\" value=\"$action\" />\n");
}

function showmainmenulink() {
  global $LangRes;
  echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3108), '', '', true).'&nbsp;&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3109), '', 'page=logout', true).'</p>');
}

function createentryparams($loosestartc = false) {
  global $GlobArr;
  return (isset($GlobArr['start']) ? '&start='.$GlobArr['start'] : '').((isset($GlobArr['startc']) && !$loosestartc) ? '&startc='.$GlobArr['startc'] : '');
}

function allessfields() {
  global $CurrentUser, $GlobArr;
  // Determine if any essential field has been left empty
  $result = true;
  $result = $result && (!$CurrentUser->IsEssentialField(0) || ($GlobArr['new_email'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(1) || ($GlobArr['new_homepage'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(2) || ($GlobArr['new_topic'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(3) || ($GlobArr['new_icqnum'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(4) || ($GlobArr['new_msn'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(5) || ($GlobArr['new_yahoo'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(6) || ($GlobArr['new_aim'] != ''));
  $result = $result && (!$CurrentUser->IsEssentialField(7) || ($GlobArr['new_skype'] != ''));
  return result;
}

function showentry($sqlobj, $page, $iscomment = false, $comcount, $iscensor = false, $contentonly = false) {
  echo(getentryhtml($sqlobj, $page, $iscomment, $comcount, $iscensor, $contentonly));
}

function getentryhtml($sqlobj, $page, $iscomment = false, $comcount, $iscensor = false, $contentonly = false) {
  global $LangRes, $CurrentUser, $GlobArr, $Setting;
  global $infolinesclassHTML, $entryheadclassHTML, $entrytopicclassHTML, $entrycontentsclassHTML, $navbarclassHTML;
  if ($sqlobj->name == '') {
    $dispname = $LangRes->GetRes(2100);
  } else {
    $dispname = $sqlobj->name;
  }
  $addinfo = '';
  $isfirst = true;
  if ($CurrentUser->IsInputFieldGen(0, $iscomment) && ($sqlobj->email != "")) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="mailto:'.AMB_MaskMailAddress($sqlobj->email).'">'.AMB_DataOutput($LangRes->GetRes(2003)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(1, $iscomment) && ($sqlobj->hp != "")) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="'.AMB_FixWebURL($sqlobj->hp).'">'.AMB_DataOutput($LangRes->GetRes(2004)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(3, $iscomment) && is_numeric($sqlobj->icqnum)) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    if ($CurrentUser->IsFlag(6)) {
      $addinfo .= '<img style="vertical-align: middle;" src="http://wwp.icq.com/scripts/online.dll?icq='.$sqlobj->icqnum.'&amp;img=5" /> ';
    }
    $addinfo .= '<a href="http://wwp.icq.com/'.AMB_DataOutput($sqlobj->icqnum, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2005)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(4, $iscomment) && ($sqlobj->msn != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="http://members.msn.com/'.AMB_DataOutput($sqlobj->msn, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2006)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(5, $iscomment) && ($sqlobj->yahoo != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="http://edit.yahoo.com/config/send_webmesg?.target='.AMB_DataOutput($sqlobj->yahoo, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2007)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(6, $iscomment) && ($sqlobj->aim != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="aim:goim?screenname='.AMB_DataOutput($sqlobj->aim, true, false).'&amp;message=Hallo.+Sind+Sie+online?">'.AMB_DataOutput($LangRes->GetRes(2008)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(7, $iscomment) && ($sqlobj->skype != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="skype:'.AMB_DataOutput($sqlobj->skype, true, false).'?chat">'.AMB_DataOutput($LangRes->GetRes(2009)).'</a>';
  }
  
  if ($addinfo != '') {
    $addinfo = '('.$addinfo.')';
  }
  // Kopf des Eintrags (+ Topic, falls erwnscht)
  $contfileline = '<p><table style="width: 90%; border-style: none">';
  if (!AMB_IsFlag($sqlobj->flags, AMBE_STICKY)) {
    $contfileline .= '<tr><td'.($iscomment ? ' class="EntryComHeadClass"' : $entryheadclassHTML).'><strong>'.AMB_InsertSmilies(AMB_DataOutputEnt($dispname))."</strong> $addinfo&nbsp;&nbsp;&nbsp;<em>".AMB_DecodeDateStamp($sqlobj->datestamp).'</em></td></tr>';
  }
  if (!$iscomment && (($CurrentUser->IsInputField(2)) && ($sqlobj->topic != ''))) {
    $contfileline .= "<tr><td$entrytopicclassHTML>".AMB_FormatFilter(AMB_DataOutput($sqlobj->topic)).'</td></tr>';
  }
  // Inhalt des Eintrags
  $contfileline .= "<tr><td$entrycontentsclassHTML>".AMB_FormatFilter(AMB_DataOutputEnt($sqlobj->contents)).'</td></tr>';
  // Webmaster-Kommentar
  if (!$iscomment && ($sqlobj->wmastcomment != '')) {
    $contfileline .= "<tr><td$entrycontentsclassHTML><em><strong>".AMB_DataOutput($CurrentUser->CommentHeading).'</strong><br />'.AMB_FormatFilter(AMB_DataOutputEnt($sqlobj->wmastcomment, false)).'</em></td></tr>';
  }
  // Steuerung von Kommentaren
  if (!$contentonly) {
    $contfileline .= "<tr><td$navbarclassHTML style=\"text-align: center\">";
    if (!$iscomment) {
      if ($iscensor) {
        $contfileline .= AMB_CreateLink($LangRes->GetRes(3100), '', 'page=rel&id='.$sqlobj->entryid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
      }
      $contfileline .= AMB_CreateLink($LangRes->GetRes(3101), '', 'page=edit&id='.$sqlobj->entryid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3102), '', 'page=del'.(($iscensor) ? 'c' : '').'&id='.$sqlobj->entryid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
      if ($CurrentUser->IsFlag(12)) {
        $contfileline .= AMB_CreateLink($LangRes->GetRes(3103).((!$iscensor) ? '' : " ($comcount)"), '', 'page='.($iscensor ? 'entcoc' : 'entco').'&id='.$sqlobj->entryid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
        $contfileline .= AMB_CreateLink((AMB_IsFlag($sqlobj->flags, 0) ? $LangRes->GetRes(3104) : $LangRes->GetRes(3105)), '', 'page=lock&id='.$sqlobj->entryid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
      }
    } else {
      if ($iscensor)
        $contfileline .= AMB_CreateLink($LangRes->GetRes(3100), '', 'page=relco&id='.$sqlobj->entryid.'&cid='.$sqlobj->comid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
      $contfileline .= AMB_CreateLink($LangRes->GetRes(3101), '', 'page=editco&id='.$sqlobj->entryid.'&cid='.$sqlobj->comid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3102), '', 'page=delco'.(($iscensor) ? 'c' : '').'&id='.$sqlobj->entryid.'&cid='.$sqlobj->comid."&from=$page".createentryparams(), true).'&nbsp;&nbsp;';
    }
    $contfileline .= '</td></tr>';
  }
  $contfileline .= '</table></p>';
  return $contfileline;
}

function showentries($page, $iscensor, $commentlist) {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $Setting;
  global $infolinesclassHTML,$entryheadclassHTML,$entrytopicclassHTML,$entrycontentsclassHTML,$navbarclassHTML;
  
  $tablesperpage = $commentlist ? $CurrentUser->CommentsPerPage : $CurrentUser->EntriesPerPage;
  
  if ($commentlist) {
    if (!isset($GlobArr['startc']) || ($GlobArr['startc'] < 1)) {
      $e1n = 1;
    } else {
      $e1n = $GlobArr['startc'];
    }
  } else {
    if (!isset($GlobArr['start']) || ($GlobArr['start'] < 1)) {
      $e1n = 1;
    } else {
      $e1n = $GlobArr['start'];
    }
  }
  
  if (!$commentlist) {
    $sql = AMB_GetEntrySQLFragment($CurrentUser->Name, false, $iscensor)." LIMIT ".sprintf("%d", $e1n - 1).','.sprintf("%d", $CurrentUser->EntriesPerPage);
    $sqlquery = mysql_query($sql, $MySQLCon);
    // Wieviele Datenstze insgesamt?
    $sql3 = "SELECT FOUND_ROWS() AS ecount";
    $sqlquery3 = mysql_query($sql3, $MySQLCon);
    $sqlobj3 = mysql_fetch_object($sqlquery3);
    if ($sqlobj3) {
      $gbfilesnum = $sqlobj3->ecount;
    } else {
      $gbfilesnum = 0;
    }
  } else {
    // Zunchst den Haupteintrag anzeigen
    $sql = "SELECT * FROM gbk WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf('%d', $GlobArr['id'])." AND censor=0 ORDER BY entryid DESC";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if (!mysql_num_rows($sqlquery) || !($sqlobj = mysql_fetch_object($sqlquery))) {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2158)).'</p>');
      mysql_free_result($sqlquery);
      return;
    }
    mysql_free_result($sqlquery);
    
    if (!$CurrentUser->IsFlag(12)) {
      // If no comments are allowed, we have nothing to do here
      showentry($sqlobj, $page, false, $gbfilesnum, $iscensor);
      return;
    }
    $sql = "SELECT SQL_CALC_FOUND_ROWS * FROM gbk_comments WHERE entryid=".sprintf('%d', $GlobArr['id'])." AND censor=".($iscensor ? '1' : '0')." ORDER BY comid DESC LIMIT ".sprintf("%d", $e1n - 1).','.sprintf("%d", $CurrentUser->CommentsPerPage);
    $sqlquery = mysql_query($sql, $MySQLCon);
    // Wieviele Datenstze insgesamt?
    $sql3 = "SELECT FOUND_ROWS() AS ecount";
    $sqlquery3 = mysql_query($sql3, $MySQLCon);
    $sqlobj3 = mysql_fetch_object($sqlquery3);
    if ($sqlobj3) {
      $gbfilesnum = $sqlobj3->ecount;
    } else {
      $gbfilesnum = 0;
    }
    showentry($sqlobj, $page, false, $gbfilesnum, $iscensor);
    if ($CurrentUser->IsFlag(12)) {
      echo('<hr size="1" />');
      echo('<h2 id="CommentTitle">'.AMB_DataOutput($LangRes->GetRes(2160)).'</h2>');
    }
  }
  
  if (!$gbfilesnum) {
    if ($commentlist) {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2161)).'</p>');
    } else {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2162)).'</p>');
    }
    mysql_free_result($sqlquery);
    return;
  }

  $sqlobj = null;
  while ($sqlobj = mysql_fetch_object($sqlquery)) {
    if (!$commentlist) {
      showentry($sqlobj, $page, false, $sqlobj->comcount, $iscensor);
    } else {
      showentry($sqlobj, $page, true, $sqlobj3->ecount, $iscensor);
    }
  }
  
  if ($gbfilesnum <= ($e1n + $tablesperpage)) {
    $e2n = $gbfilesnum;
  } else {
    $e2n = $e1n + $tablesperpage;
  }
  
  if (($e1n <= 1) || ($e1n > $e2n)) {
    $e1n = 1;
    $firstapproached = true;
  }
  if (($e2n - $e1n) != ($tablesperpage - 1)) {
    $e2n = $e1n + $tablesperpage - 1;
  }
  if ($e2n >= $gbfilesnum) {
    $e2n = $gbfilesnum;
    $lastapproached = true;
  }
  
  if ($sqlquery) mysql_free_result($sqlquery);
  if ($sqlquery2) mysql_free_result($sqlquery2);
  if ($sqlquery3) mysql_free_result($sqlquery3);
    
  echo('<p><table><tr><td'.$navbarclassHTML.'>');
  $e1n_next = $e1n + $tablesperpage;
  $e2n_next = $e2n + $tablesperpage;
  $e1n_prev = $e1n - $tablesperpage;
  $e2n_prev = $e2n - $tablesperpage;
  
  if ($commentlist && isset($GlobArr['start'])) {
    $startfol = '&start='.$GlobArr['start'];
  } else {
    $startfol = '';
  }
  if (!$firstapproached) {
    echo(AMB_CreateLink($LangRes->GetRes(2164, array(1=>$tablesperpage)), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').($singleview ? 'eid='.$GlobArr['eid'].'&' : '').'page='.$GlobArr['page']."&start=$e1n_prev").'&nbsp;&nbsp;&nbsp;');
  }
  echo($LangRes->GetRes(2165, array(1=>'<b>'.$e1n.'</b>', 2=>'<b>'.$e2n.'</b>', 3=>'<b>'.$gbfilesnum.'</b>')));
  if (!$lastapproached) {
    echo('&nbsp;&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(2166, array(1=>$tablesperpage)), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').($singleview ? 'eid='.$GlobArr['eid'].'&' : '').'page='.$GlobArr['page']."&start=$e1n_next"));
  }
  echo('</td></tr></table></p>');
}

function mail_accdel($accname, $dataremoved) {
  global $LangRes, $Setting;
  $mailmessage = $LangRes->GetRes(3901)."\n\n";
  if ($dataremoved) {
  $mailmessage .= $LangRes->GetRes(3902)."\n\n";
  } else {
  $mailmessage .= $LangRes->GetRes(3903)."\n\n";
  }
  $mailmessage.="\n### ".AMBVERSION."\n### (c) ".AMBCOPYRIGHT;
  // mail input
  @mail($Setting[CONF_ADMINMAIL], $LangRes->GetRes(3900), $mailmessage, 'From: '.$Setting[CONF_MAILFROM]."\r\nX-Mailer: ".AMB_GetXMailer());
}

function adminarea() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  // Falls Daten im Input-Cache gespeichert werden sollen, dies jetzt (vor der ersten Ausgabe) tun!
  if ((isset($GlobArr['page']) && ($GlobArr['page'] == 'edit')) && (isset($GlobArr['action']) && ($GlobArr['action'] == 'save')) && !isset($GlobArr['id'])) {
    $UserInputCache['name'] = $GlobArr['new_name'];
    $UserInputCache['email'] = $GlobArr['new_email'];
    $UserInputCache['homepage'] = $GlobArr['new_homepage'];
    $UserInputCache['icqnum'] = $GlobArr['new_icqnum'];
    AMB_SaveInputCache();
  }
  AMB_ReadInputCache();
  AMB_ShowHTMLHeading();
  switch ($GlobArr['page']) {
    case 'logout':
      // Zerstren der Session (Log out)
      AMB_session_destroy();
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3001)).'</h1><p>'.AMB_DataOutput($LangRes->GetRes(3002)).'</p><p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3003), '', '').'</p>');
      break;
    case 'gen':
      admin_gen();
      break;
    case 'des':
      admin_des();
      break;
    case 'data':
      admin_data();
      break;
    case 'ent':
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3004)).'</h1>');
      showmainmenulink();
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES)) {
        echo('<p><table><tr><td class="NavBarClass" style="text-align: center">'.AMB_CreateLink($LangRes->GetRes(3106), '', 'page=edit&from=ent', true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3107), '', 'page=del&from=ent'.createentryparams(), true).'</td></tr></table></p>');
        showentries($GlobArr['page'], false, false);
      } else {
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(1006)).'</p>');
      }
      break;
    case 'entc':
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3005)).'</h1>');
      showmainmenulink();
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) && $CurrentUser->IsFlag(AMBU_CENSOR)) {
        echo('<p><table><tr><td class="NavBarClass" style="text-align: center">'.AMB_CreateLink($LangRes->GetRes(3110), '', 'page=rel&from=entc', true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3111), '', 'page=delc&from=entc'.createentryparams(), true).'</td></tr></table></p>');
        showentries($GlobArr['page'], true, false);
      } else {
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(1006)).'</p>');
      }
      break;
    case 'entco':
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3006)).'</h1>');
      showmainmenulink();
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES)) {
        echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3112), '', 'page=ent'.createentryparams(true), true).'</p>');
        echo('<p><table><tr><td class="NavBarClass" style="text-align: center">'.AMB_CreateLink($LangRes->GetRes(3111), '', 'page=delco&id='.$GlobArr['id'].'&from=entco'.createentryparams(), true).'</td></tr></table></p>');
        showentries($GlobArr['page'], false, true);
      } else {
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(1006)).'</p>');
      }
      break;
    case 'entcoc':
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3007)).'</h1>');
      showmainmenulink();
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) && $CurrentUser->IsFlag(AMBU_CENSOR)) {
        echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3112), '', 'page=entc'.createentryparams(true), true).'</p>');
        echo('<p><table><tr><td class="NavBarClass" style="text-align: center">'.AMB_CreateLink($LangRes->GetRes(3110), '', 'page=relco&id='.$GlobArr['id'].'&from=entcoc', true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3111), '', 'page=delcoc&id='.$GlobArr['id'].'&from=entcoc'.createentryparams(), true).'</td></tr></table></p>');
        showentries($GlobArr['page'], true, true);
      } else {
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(1006)).'</p>');
      }
      break;
    case 'edit':
    case 'editco':
      admin_edit();
      break;
    case 'del':
    case 'delc':
    case 'delco':
    case 'delcoc':
      admin_del();
      break;
    case 'rel':
    case 'relco':
      admin_rel();
      break;
    case 'accman':
      if ($Setting[CONF_SUPERADMIN] == $CurrentUser->Name) {
        admin_accman();
      } else {
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(1006)).'</p>');
      }
      break;
    case 'lock':
      admin_lock();
      break;
    case 'delacc':
      admin_delacc();
      break;
    default:
      // Hauptmen des Administrationsbereichs
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3010)).'</h1>');
      echo('<p class="InfoLinesClass">'.AMB_DataOutput($LangRes->GetRes(3011, array(1=>$CurrentUser->Name))).'</p>');
      echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3012), '', 'page=gen', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3013)).'</p>');
      echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3014), '', 'page=des', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3015)).'</p>');
      echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3016), '', 'page=data', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3017)).'</p>');
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES)) {
        echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3018), '', 'page=ent', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3019)).'</p>');
      }
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) && $CurrentUser->IsFlag(AMBU_CENSOR)) {
        echo("<p class=\"InfoLinesClass\">".AMB_CreateLink($LangRes->GetRes(3020), '', 'page=entc', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3021)).'</p>');
      }
      if ($Setting[CONF_SUPERADMIN] == $CurrentUser->Name) {
        echo("<p class=\"InfoLinesClass\">".AMB_CreateLink($LangRes->GetRes(3070), '', 'page=accman', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3071)).'</p>');
      }
      echo("<p class=\"InfoLinesClass\">".AMB_CreateLink($LangRes->GetRes(3022), '', 'page=delacc', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3023)).'</p>');
      echo("<p class=\"InfoLinesClass\">".AMB_CreateLink($LangRes->GetRes(3001), '', 'page=logout', true).'<br />'.AMB_DataOutput($LangRes->GetRes(3024)).'</p>');
      break; 
  }
  AMB_ShowHTMLEnding();
}

function admin_gen() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3012))."</h1>\n<p>");
  if ($GlobArr['action'] == "save") {
    if ($GlobArr['pwd1'] != $GlobArr['pwd2']) {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(3025)).'</p>');
    } else {
      $sql = "UPDATE gbk_users SET ";
      $sql .= "gbtitle='".AMB_SecSQL($GlobArr['title'])."', ";
      $sql .= "gbdesc='".AMB_SecSQL($GlobArr['desc'])."', ";
      $sql .= "commenthead='".AMB_SecSQL($GlobArr['wmastcomment'])."', ";
      $epp = sprintf('%d', $GlobArr['epp']);
      if ($epp < 1) {
        $epp = 1;
      } elseif ($epp > 25) {
        $epp = 25;
      }
      $cpp = sprintf('%d', $GlobArr['cpp']);
      if ($cpp < 1) {
        $cpp = 1;
      } elseif ($cpp > 25) {
        $cpp = 25;
      }
      $sql .= "entriesperpage=".$epp.", ";
      $sql .= "commentsperpage=".$cpp.", ";
      $sql .= "mailaddress='".AMB_SecSQL($GlobArr['mailaddr'])."', ";
      if ($GlobArr['pwd1'] != "") {
        $hash = md5($GlobArr['pwd1']);
        $sql .= "userpwd='".AMB_SecSQL($hash)."', ";
      }
      $flags = 0;
      if (isset($GlobArr['usesmilies'])) $flags = $flags | 16;
      if (isset($GlobArr['allowhtml'])) $flags = $flags | 4;
      if (isset($GlobArr['censoring'])) $flags = $flags | 1;
      if (isset($GlobArr['mailme'])) $flags = $flags | 2;
      if (isset($GlobArr['weblog'])) $flags = $flags | 32;
      if (isset($GlobArr['rssbutton'])) $flags = $flags | 128;
      if (isset($GlobArr['rssshowtopic'])) $flags = $flags | 256;
      if (isset($GlobArr['nousercache'])) $flags = $flags | 512;
      if (isset($GlobArr['forumlike'])) $flags = $flags | 1024;
      if (isset($GlobArr['extrainputpage'])) $flags = $flags | (1 << 11);
      if (isset($GlobArr['allowcomments'])) $flags = $flags | (1 << 12);
      if (isset($GlobArr['mailmecom'])) $flags = $flags | (1 << 13);
      if (isset($GlobArr['sortbycomment'])) $flags = $flags | (1 << 14);
      if (isset($GlobArr['dontsaveentries'])) {
        $flags = $flags | (1 << 15);
        $flags = $flags | 2;
      }
      if (isset($GlobArr['userdisplaymode'])) $flags = $flags | (1 << AMBU_USERDISPLAYMODE);
      if ($CurrentUser->UseCSS) $flags = $flags | 8;
      if ($CurrentUser->IsFlag(6)) $flags = $flags | 64;
      $sql .= "flags=".$flags." WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
      $sqlquery = mysql_query($sql, $MySQLCon);
      if ($sqlquery) {
        // Aktualisieren der Daten
        if ($GlobArr['pwd1'] != '')
          $CurrentUser->Pwd = AMB_MagicUnQuote($hash);
        $CurrentUser->GBTitle = AMB_MagicUnQuote($GlobArr['title']);
        $CurrentUser->GBDescription = AMB_MagicUnQuote($GlobArr['desc']);
        $CurrentUser->UseSmilies = isset($GlobArr['usesmilies']);
        $CurrentUser->AllowHTML = isset($GlobArr['allowhtml']);
        $CurrentUser->EntriesPerPage = $epp;
        $CurrentUser->CommentsPerPage = $cpp;
        $CurrentUser->CommentHeading = AMB_MagicUnQuote($GlobArr['wmastcomment']);
        $CurrentUser->Censoring = isset($GlobArr['censoring']);
        $CurrentUser->MailMe = (isset($GlobArr['mailme']) || AMB_IsFlag($flags, 15));
        $CurrentUser->MailAddress = AMB_MagicUnQuote($GlobArr['mailaddr']);
        $CurrentUser->UseAsBlog = isset($GlobArr['weblog']);
        $CurrentUser->Flags = $flags;
      } else {
        $tempoutput = AMB_DataOutput($LangRes->GetRes(3026));
        echo('<p class="InfoLinesClass">'.$LangRes->InsertResParams($tempoutput, array(1=>'<a href="mailto:'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'">'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'</a>')).'</p>');
      }
    }
  }
  showmainmenulink();
  showformhead('gen', 'save');
  echo('<table><tr><td style="text-align: left">
  <fieldset style="margin-bottom: 15px"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3300)).'</legend><table style="margin: 2px">
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3301)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="title" value="'.AMB_DataOutput($CurrentUser->GBTitle, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o1').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3302)).':&nbsp;</td><td><input type="checkbox" name="usesmilies"'.(($CurrentUser->UseSmilies) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o2').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3303)).':&nbsp;</td><td><input type="checkbox" name="allowhtml"'.(($CurrentUser->AllowHTML) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o3').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3304)).':&nbsp;</td><td><input type="checkbox" name="forumlike"'.(($CurrentUser->IsFlag(10)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o4').'</td></tr>
  <tr><td>&nbsp;</td><td><input type="checkbox" name="userdisplaymode"'.(($CurrentUser->IsFlag(AMBU_USERDISPLAYMODE)) ? " checked=\"checked\"" : '').' />&nbsp;'.AMB_DataOutput($LangRes->GetRes(3347)).'</td><td>'.AMB_GetAdminHelpLink('gen1', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3305)).':&nbsp;</td><td><input type="checkbox" name="sortbycomment"'.(($CurrentUser->IsFlag(14)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o5').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3306)).':&nbsp;</td><td><input class="TextBoxClass" size="5" type="text" name="epp" value="'.AMB_DataOutput($CurrentUser->EntriesPerPage, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o6').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3307)).':&nbsp;</td><td><input class="TextBoxClass" size="5" type="text" name="cpp" value="'.AMB_DataOutput($CurrentUser->CommentsPerPage, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o7').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3308)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="wmastcomment" value="'.AMB_DataOutput($CurrentUser->CommentHeading, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o8').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3309)).':&nbsp;</td><td><input type="checkbox" name="extrainputpage"'.(($CurrentUser->IsFlag(11)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen1', 'o9').'</td></tr>
  </table></fieldset>
  
  <fieldset style="margin-bottom: 15px"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3310)).'</legend><table style="margin: 2px">
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3325)).':&nbsp;</td><td><input type="checkbox" name="dontsaveentries"'.(($CurrentUser->IsFlag(15)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o1').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3311)).':&nbsp;</td><td><input type="checkbox" name="weblog"'.(($CurrentUser->UseAsBlog) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o2').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3312)).':&nbsp;</td><td><input type="checkbox" name="nousercache"'.(($CurrentUser->IsFlag(9)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o3').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3313)).':&nbsp;</td><td><input type="checkbox" name="allowcomments"'.(($CurrentUser->IsFlag(12)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3314)).':&nbsp;</td><td><input type="checkbox" name="censoring"'.(($CurrentUser->Censoring) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o5').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3315)).':&nbsp;</td><td><input type="checkbox" name="mailme"'.(($CurrentUser->MailMe) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o6').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3316)).':&nbsp;</td><td><input type="checkbox" name="mailmecom"'.(($CurrentUser->IsFlag(13)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen2', 'o7').'</td></tr>
  </table></fieldset>
  
  <fieldset style="margin-bottom: 15px"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3317)).'</legend><table style="margin: 2px">
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3318)).':&nbsp;</td><td><input type="checkbox" name="rssbutton"'.(($CurrentUser->IsFlag(7)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen3', 'o1').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3319)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="desc" value="'.AMB_DataOutput($CurrentUser->GBDescription, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen3', 'o2').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3320)).':&nbsp;</td><td><input type="checkbox" name="rssshowtopic"'.(($CurrentUser->IsFlag(8)) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('gen3', 'o3').'</td></tr>
  </table></fieldset>
  
  <fieldset style="margin-bottom: 15px"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3321)).'</legend><table style="margin: 2px">
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3322)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="mailaddr" value="'.AMB_DataOutput($CurrentUser->MailAddress, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('gen4', 'o1').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3323)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="password" name="pwd1" value="" /></td><td>'.AMB_GetAdminHelpLink('gen4', 'o2').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3324)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="password" name="pwd2" value="" /></td><td>'.AMB_GetAdminHelpLink('gen4', 'o3').'</td></tr>
  </table></fieldset>
  
  <div style="text-align: center"><input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3053), true).'" />&nbsp;<input class="ButtonClass" value="'.AMB_DataOutput($LangRes->GetRes(2105), true).'" type="reset" /></div>
  </td></tr></table>
  </form></p>
  ');
}

function admin_des() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  echo("<h1 id=\"GBTitle\">".AMB_DataOutput($LangRes->GetRes(3326))."</h1>\n<p>");
  if ($GlobArr['action'] == 'save') {
    $sql = "UPDATE gbk_users SET ";
    $sql .= "logopic='".AMB_SecSQL($GlobArr['logopic'])."', ";
    $sql .= "cssfile='".AMB_SecSQL($GlobArr['cssfile'])."', ";
    $sql .= "backgroundcolor='".AMB_SecSQL($GlobArr['bgcolor'])."', ";
    $sql .= "backgroundpic='".AMB_SecSQL($GlobArr['bgpic'])."', ";
    $sql .= "gbtitlecolor='".AMB_SecSQL($GlobArr['titlecolor'])."', ";
    $sql .= "textcolor='".AMB_SecSQL($GlobArr['textcolor'])."', ";
    $sql .= "linkcolor='".AMB_SecSQL($GlobArr['linkcolor'])."', ";
    $sql .= "tblcolorhead='".AMB_SecSQL($GlobArr['entryhead'])."', ";
    $sql .= "tblcolorentry='".AMB_SecSQL($GlobArr['entrybody'])."', ";
    $flags = $CurrentUser->Flags;
    if (isset($GlobArr['usecss'])) {
      $flags = $flags | 8;
    } else {
      $flags = $flags & ~8;
    }
    $sql .= "flags=".$flags." WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if ($sqlquery) {
      // Aktualisieren der Daten
      $CurrentUser->LogoPic = AMB_MagicUnQuote($GlobArr['logopic']);
      $CurrentUser->CSSFile = AMB_MagicUnQuote($GlobArr['cssfile']);
      $CurrentUser->BackgroundColor = AMB_MagicUnQuote($GlobArr['bgcolor']);
      $CurrentUser->BackgroundPic = AMB_MagicUnQuote($GlobArr['bgpic']);
      $CurrentUser->GBTitleColor = AMB_MagicUnQuote($GlobArr['titlecolor']);
      $CurrentUser->TextColor = AMB_MagicUnQuote($GlobArr['textcolor']);
      $CurrentUser->LinkColor = AMB_MagicUnQuote($GlobArr['linkcolor']);
      $CurrentUser->EntryHead = AMB_MagicUnQuote($GlobArr['entryhead']);
      $CurrentUser->EntryBody = AMB_MagicUnQuote($GlobArr['entrybody']);
      $CurrentUser->UseCSS = isset($GlobArr['usecss']);
      $CurrentUser->Flags = $flags;
    } else {
      $tempoutput = AMB_DataOutput($LangRes->GetRes(3026));
      echo('<p class="InfoLinesClass">'.$LangRes->InsertResParams($tempoutput, array(1=>'<a href="mailto:'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'">'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'</a>')).'</p>');
    }
  }
  showmainmenulink();
  AMB_InitColorPicker();
  showformhead('des', 'save');
  echo('<table class="InfoLinesClass">
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3327)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="logopic" value="'.AMB_DataOutput($CurrentUser->LogoPic, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('des', 'o1').'</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3328)).':&nbsp;</td><td><input type="checkbox" name="usecss"'.(($CurrentUser->UseCSS) ? " checked=\"checked\"" : '').' /></td><td>'.AMB_GetAdminHelpLink('des', 'o2').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3329)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="cssfile" value="'.AMB_DataOutput($CurrentUser->CSSFile, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('des', 'o3').'</td></tr>
  <tr><td>&nbsp;</td><td><a target="_blank" href="'.$Setting[CONF_CSSGENSCRIPT].'?{sample}">'.AMB_DataOutput($LangRes->GetRes(3330)).'</a></td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3331)).':&nbsp;</td><td><input id="bgcolorin" class="TextBoxClass" size="40" type="text" name="bgcolor" value="'.AMB_DataOutput($CurrentUser->BackgroundColor, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('bgcolorin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3332)).':&nbsp;</td><td><input class="TextBoxClass" size="40" type="text" name="bgpic" value="'.AMB_DataOutput($CurrentUser->BackgroundPic, false, false).'" /></td><td>'.AMB_GetAdminHelpLink('des', 'o5').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3333)).':&nbsp;</td><td><input id="titlecolorin" class="TextBoxClass" size="40" type="text" name="titlecolor" value="'.AMB_DataOutput($CurrentUser->GBTitleColor, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('titlecolorin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3334)).':&nbsp;</td><td><input id="textcolorin" class="TextBoxClass" size="40" type="text" name="textcolor" value="'.AMB_DataOutput($CurrentUser->TextColor, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('textcolorin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3335)).':&nbsp;</td><td><input id="linkcolorin" class="TextBoxClass" size="40" type="text" name="linkcolor" value="'.AMB_DataOutput($CurrentUser->LinkColor, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('linkcolorin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3336)).':&nbsp;</td><td><input id="entryheadin" class="TextBoxClass" size="40" type="text" name="entryhead" value="'.AMB_DataOutput($CurrentUser->EntryHead, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('entryheadin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(3337)).':&nbsp;</td><td><input id="entrybodyin" class="TextBoxClass" size="40" type="text" name="entrybody" value="'.AMB_DataOutput($CurrentUser->EntryBody, false, false).'" '.AMB_GetPickerHandlers().' />'.AMB_CreateColorPicker('entrybodyin').'</td><td>'.AMB_GetAdminHelpLink('des', 'o4').'</td></tr>
  <tr><td>&nbsp;</td><td>&nbsp;</td></tr>
  <tr><td>&nbsp;</td><td><input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3053), true).'" />&nbsp;<input class="ButtonClass" value="'.AMB_DataOutput($LangRes->GetRes(2105), true).'" type="reset" /></td><td>&nbsp;</td></tr>
  </table>
  </form></p>
  ');
}

function admin_data() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  echo("<h1 id=\"GBTitle\">".AMB_DataOutput($LangRes->GetRes(3338))."</h1>\n<p>");
  if ($GlobArr['action'] == "save") {
    $sql = "UPDATE gbk_users SET ";
    $datafields = 0;
    $datafieldsc = 0;
    $essfields = 0;
    $flags = $CurrentUser->Flags;
    if (isset($GlobArr['icqonline'])) {
      $flags = $flags | 64;
    } else {
      $flags = $flags & ~64;
    }
    if (isset($GlobArr['topic'])) $datafields = $datafields | 4;
    if (isset($GlobArr['email'])) $datafields = $datafields | 1;
    if (isset($GlobArr['hp'])) $datafields = $datafields | 2;
    if (isset($GlobArr['icq'])) $datafields = $datafields | 8;
    if (isset($GlobArr['msn'])) $datafields = $datafields | 16;
    if (isset($GlobArr['yahoo'])) $datafields = $datafields | 32;
    if (isset($GlobArr['aim'])) $datafields = $datafields | 64;
    if (isset($GlobArr['skype'])) $datafields = $datafields | 128;
    if (isset($GlobArr['email_c'])) $datafieldsc = $datafieldsc | 1;
    if (isset($GlobArr['hp_c'])) $datafieldsc = $datafieldsc | 2;
    if (isset($GlobArr['icq_c'])) $datafieldsc = $datafieldsc | 8;
    if (isset($GlobArr['msn_c'])) $datafieldsc = $datafieldsc | 16;
    if (isset($GlobArr['yahoo_c'])) $datafieldsc = $datafieldsc | 32;
    if (isset($GlobArr['aim_c'])) $datafieldsc = $datafieldsc | 64;
    if (isset($GlobArr['skype_c'])) $datafieldsc = $datafieldsc | 128;
    if (isset($GlobArr['topic_e'])) $essfields = $essfields | 4;
    if (isset($GlobArr['email_e'])) $essfields = $essfields | 1;
    if (isset($GlobArr['hp_e'])) $essfields = $essfields | 2;
    if (isset($GlobArr['icq_e'])) $essfields = $essfields | 8;
    if (isset($GlobArr['msn_e'])) $essfields = $essfields | 16;
    if (isset($GlobArr['yahoo_e'])) $essfields = $essfields | 32;
    if (isset($GlobArr['aim_e'])) $essfields = $essfields | 64;
    if (isset($GlobArr['skype_e'])) $essfields = $essfields | 128;
    $sql .= "datafields=".$datafields.", ";
    $sql .= "datafieldscom=".$datafieldsc.", ";
    $sql .= "essfields=".$essfields.", ";
    $sql .= "flags=".$flags." WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if ($sqlquery) {
      // Aktualisieren der Daten
      $CurrentUser->InputFields = $datafields;
      $CurrentUser->ComInputFields = $datafieldsc;
      $CurrentUser->EssentialFields = $essfields;
      $CurrentUser->Flags = $flags;
    } else {
      $tempoutput = AMB_DataOutput($LangRes->GetRes(3026));
      echo('<p class="InfoLinesClass">'.$LangRes->InsertResParams($tempoutput, array(1=>'<a href="mailto:'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'">'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'</a>')).'</p>');
    }
  }
  showmainmenulink();
  showformhead('data', 'save');
  echo('<table class="ContentTableClass">
  <tr><th>&nbsp;</th><th>'.AMB_DataOutput($LangRes->GetRes(3339)).AMB_GetAdminHelpLink('data', 'o1').'</th><th>'.AMB_DataOutput($LangRes->GetRes(3340)).AMB_GetAdminHelpLink('data', 'o2').'</th><th>'.AMB_DataOutput($LangRes->GetRes(3341)).AMB_GetAdminHelpLink('data', 'o3').'</th></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2002)).':&nbsp;</td><td><input type="checkbox" name="topic"'.(($CurrentUser->IsInputField(2)) ? ' checked="checked"' : '').' /></td><td>&nbsp;</td><td><input type="checkbox" name="topic_e"'.(($CurrentUser->IsEssentialField(2)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2003)).':&nbsp;</td><td><input type="checkbox" name="email"'.(($CurrentUser->IsInputField(0)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="email_c"'.(($CurrentUser->IsComInputField(0)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="email_e"'.(($CurrentUser->IsEssentialField(0)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2004)).':&nbsp;</td><td><input type="checkbox" name="hp"'.(($CurrentUser->IsInputField(1)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="hp_c"'.(($CurrentUser->IsComInputField(1)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="hp_e"'.(($CurrentUser->IsEssentialField(1)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2005)).':&nbsp;</td><td><input type="checkbox" name="icq"'.(($CurrentUser->IsInputField(3)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="icq_c"'.(($CurrentUser->IsComInputField(3)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="icq_e"'.(($CurrentUser->IsEssentialField(3)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>&nbsp;</td><td style="text-align: center;" colspan="3"><input type="checkbox" name="icqonline"'.(($CurrentUser->IsFlag(6)) ? ' checked="checked"' : '').' />&nbsp;'.AMB_DataOutput($LangRes->GetRes(3342)).AMB_GetAdminHelpLink('data', 'o4').'</td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2006)).':&nbsp;</td><td><input type="checkbox" name="msn"'.(($CurrentUser->IsInputField(4)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="msn_c"'.(($CurrentUser->IsComInputField(4)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="msn_e"'.(($CurrentUser->IsEssentialField(4)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2007)).':&nbsp;</td><td><input type="checkbox" name="yahoo"'.(($CurrentUser->IsInputField(5)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="yahoo_c"'.(($CurrentUser->IsComInputField(5)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="yahoo_e"'.(($CurrentUser->IsEssentialField(5)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2008)).':&nbsp;</td><td><input type="checkbox" name="aim"'.(($CurrentUser->IsInputField(6)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="aim_c"'.(($CurrentUser->IsComInputField(6)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="aim_e"'.(($CurrentUser->IsEssentialField(6)) ? ' checked="checked"' : '').' /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(2009)).':&nbsp;</td><td><input type="checkbox" name="skype"'.(($CurrentUser->IsInputField(7)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="skype_c"'.(($CurrentUser->IsComInputField(7)) ? ' checked="checked"' : '').' /></td><td><input type="checkbox" name="skype_e"'.(($CurrentUser->IsEssentialField(7)) ? ' checked="checked"' : '').' /></td></tr>
  </table>
  <p style="text-align: center"><input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3053), true).'" />&nbsp;<input class="ButtonClass" value="'.AMB_DataOutput($LangRes->GetRes(2105), true).'" type="reset" /></p>
  </form></p>
  ');
}

function admin_edit() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  $errorocc = false;
  $editcom = ($GlobArr['page'] == 'editco');
  if ($GlobArr['action'] == 'save') {
    $new_contents = ($GlobArr['new_input'] == '') ? ' ' : $GlobArr['new_contents'];
    $flags = (($GlobArr['isclosed'] == '1') ? 1 << AMBE_CLOSEDTOPIC : 0) | (isset($GlobArr['new_issticky']) ? 1 << AMBE_STICKY : 0);
    // Save entry
    if (!(!isset($GlobArr['id']) && $editcom)) {
      if (!((!$editcom && isset($GlobArr['id'])) || ($editcom && isset($GlobArr['cid'])))) {
        $sql = "INSERT INTO ".($editcom ? 'gbk_comments' : 'gbk')." (username,name,email,hp,datestamp,contents,censor,".(!$editcom ? 'topic,wmastcomment,' : 'entryid,')."icqnum,msn,yahoo,aim,skype,flags) VALUES ";
        $sql .= "('".AMB_SecSQL($CurrentUser->Name)."','".AMB_SecSQL($GlobArr['new_name'])."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_email'])."','".AMB_SecSQL($GlobArr['new_homepage'])."','".AMB_GenDateStamp()."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_input'])."',";
        $sql .= '0,';
        if (!$editcom) {
          $sql .= "'".AMB_SecSQL($GlobArr['new_topic'])."',";
          $sql .= "'".AMB_SecSQL($GlobArr['new_wmastcomment'])."',";
        } else {
          $sql .= sprintf('%d', $GlobArr['id']).",";
        }
        $sql .= "'".AMB_SecSQL($GlobArr['new_icqnum'])."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_msn'])."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_yahoo'])."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_aim'])."',";
        $sql .= "'".AMB_SecSQL($GlobArr['new_skype'])."',";
        $sql .= $flags.")";
        $result = mysql_query($sql, $MySQLCon);
        if ($editcom) {
          $cid = mysql_insert_id($MySQLCon);
          $id = sprintf('%d', $GlobArr['id']);
        } else {
          $id = mysql_insert_id($MySQLCon);
        }
      } else {
        $sql = "UPDATE ".($editcom ? 'gbk_comments' : 'gbk')." SET ";
        $sql .= "name='".AMB_SecSQL($GlobArr['new_name'])."'";
        if (!$editcom) {
          if ($CurrentUser->IsInputField(2))
            $sql .= ", topic='".AMB_SecSQL($GlobArr['new_topic'])."'";
          $sql .= ", wmastcomment='".AMB_SecSQL($GlobArr['new_wmastcomment'])."'";
        }
        if ($CurrentUser->IsInputField(0))
          $sql .= ", email='".AMB_SecSQL($GlobArr['new_email'])."'";
        if ($CurrentUser->IsInputField(1))
          $sql .= ", hp='".AMB_SecSQL($GlobArr['new_homepage'])."'";
        if ($CurrentUser->IsInputField(3))
          $sql .= ", icqnum='".AMB_SecSQL($GlobArr['new_icqnum'])."'";
        if ($CurrentUser->IsInputField(4))
          $sql .= ", msn='".AMB_SecSQL($GlobArr['new_msn'])."'";
        if ($CurrentUser->IsInputField(5))
          $sql .= ", yahoo='".AMB_SecSQL($GlobArr['new_yahoo'])."'";
        if ($CurrentUser->IsInputField(6))
          $sql .= ", aim='".AMB_SecSQL($GlobArr['new_aim'])."'";
        if ($CurrentUser->IsInputField(7))
          $sql .= ", skype='".AMB_SecSQL($GlobArr['new_skype'])."'";
        $sql .= ", contents='".AMB_SecSQL($GlobArr['new_input'])."'";
        $sql .= ", flags=".$flags;
        $sql .= " WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf('%d', $GlobArr['id']);
        if ($editcom)
          $sql .= " AND comid=".sprintf('%d', $GlobArr['cid']);
        $result = mysql_query($sql, $MySQLCon);
        if ($editcom)
          $cid = sprintf('%d', $GlobArr['cid']);
        $id = sprintf('%d', $GlobArr['id']);
      }
    }
    if (!$result || (@mysql_affected_rows($MySQLCon) < 1)) {
      echo('<p class="InfoLinesClass">'.AMB_DataOutput($LangRes->GetRes(3027)).'</p>');
    } else {
      $GlobArr['id'] = $id;
      if ($editcom)
        $GlobArr['cid'] = $cid;
    }
  }
  $editexisting = ((!$editcom && isset($GlobArr['id'])) || ($editcom && isset($GlobArr['cid'])));
  if ($editexisting) {
    if ($editcom) {
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3029)).'</h1>');
    } else {
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3028)).'</h1>');
    }
    $newentry = false;
    $sql = "SELECT * FROM ".($editcom ? 'gbk_comments' : 'gbk')." WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf('%d', $GlobArr['id']);
    if ($editcom)
      $sql .= " AND comid=".sprintf("%d", $GlobArr['cid']);
    $sqlquery = mysql_query($sql, $MySQLCon);
    if ($sqlquery && (@mysql_num_rows($sqlquery) > 0)) {
      $row = mysql_fetch_object($sqlquery);
      $f_name = AMB_DataOutput($row->name, false, false);
      if (!$editcom) {
        $f_topic = AMB_DataOutput($row->topic, false, false);
        $f_wmastcomment = AMB_DataOutput($row->wmastcomment, true, false);
      }
      $f_email = AMB_DataOutput($row->email, false, false);
      $f_hp = AMB_DataOutput($row->hp, false, false);
      $f_icqnum = AMB_DataOutput($row->icqnum, false, false);
      $f_msn = AMB_DataOutput($row->msn, false, false);
      $f_yahoo = AMB_DataOutput($row->yahoo, false, false);
      $f_aim = AMB_DataOutput($row->aim, false, false);
      $f_skype = AMB_DataOutput($row->skype, false, false);
      $f_contents = AMB_DataOutput($row->contents, true, false);
      $f_isclosed = AMB_IsFlag($row->flags, AMBE_CLOSEDTOPIC) ? '1' : '0';
      $f_issticky = AMB_IsFlag($row->flags, AMBE_STICKY);
      // We have to call getentryhtml() here, because it needs a fetched sql object
      $entryoutput = getentryhtml($row, $GlobArr['page'], $editcom, 0, false, true);
    }
    if ($sqlquery) mysql_free_result($sqlquery);
  } else {
    if ($editcom) {
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3031)).'</h1>');
    } else {
      echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3030)).'</h1>');
    }
    $newentry = true;
    $f_name = (isset($UserInputCache['name'])) ? AMB_DataOutput($UserInputCache['name'], false, false) : '';
    $f_topic = '';
    $f_email = (isset($UserInputCache['email'])) ? AMB_DataOutput($UserInputCache['email'], false, false) : '';
    $f_hp = (isset($UserInputCache['homepage'])) ? AMB_DataOutput($UserInputCache['homepage'], false, false) : '';
    $f_icqnum = (isset($UserInputCache['icqnum'])) ? AMB_DataOutput($UserInputCache['icqnum'], false, false) : '';
    $f_msn = (isset($UserInputCache['msn'])) ? AMB_DataOutput($UserInputCache['msn'], false, false) : '';
    $f_yahoo = (isset($UserInputCache['yahoo'])) ? AMB_DataOutput($UserInputCache['yahoo'], false, false) : '';
    $f_aim = (isset($UserInputCache['aim'])) ? AMB_DataOutput($UserInputCache['aim'], false, false) : '';
    $f_skype = (isset($UserInputCache['skype'])) ? AMB_DataOutput($UserInputCache['skype'], false, false) : '';
    $f_isclosed = '0';
    $f_issticky = false;
    $f_contents = '';
    $f_wmastcomment = '';
  }
  showmainmenulink();
  echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3113), '', 'page='.$GlobArr['from'].createentryparams(!$editcom).($editcom ? '&id='.$GlobArr['id'] : ''), true).'</p>');
  if ($editexisting) {
    echo('<hr size="1" />');
    echo($entryoutput);
    echo('<hr size="1" />');
  }
  if ($row || $newentry) {
    $inputformHTML = ' class="InputFormClass"';
    $textboxclassHTML = ' class="TextBoxClass"';
    $buttonclassHTML = ' class="ButtonClass"';
    $infolinesclassHTML = ' class="InfoLinesClass"';
    echo("<p><span$infolinesclassHTML><small>");
    if ($CurrentUser->AllowHTML) {
      $LangRes->AddRes(2112, AMB_DataOutput($LangRes->GetRes(2112)));
      echo($LangRes->GetRes(2112, array(1=>'<a target="_blank" href="'.$Setting[CONF_HELPSCRIPT].'?user='.$CurrentUser->Name.'&amp;page=bbcodes">'.AMB_DataOutput($LangRes->GetRes(2111)).'</a>')).'<br />');
    }
    if ($CurrentUser->UseSmilies) {
      $LangRes->AddRes(2114, AMB_DataOutput($LangRes->GetRes(2114)));
      echo($LangRes->GetRes(2114, array(1=>'<a target="_blank" href="'.$Setting[CONF_HELPSCRIPT].'?user='.$CurrentUser->Name.'&amp;page=smilies">'.AMB_DataOutput($LangRes->GetRes(2113)).'</a>')).'<br />');
    }
    echo('</small></span></p>');
    echo('<p>');
    showformhead($GlobArr['page'], 'save');
    echo('<input type="hidden" name="from" value="'.AMB_DataOutput($GlobArr['from'], false, false).'" />');
    if (isset($GlobArr['start']))
      echo('<input type="hidden" name="start" value="'.AMB_DataOutput($GlobArr['start'], false, false).'" />');
    if (isset($GlobArr['startc']))
      echo('<input type="hidden" name="startc" value="'.AMB_DataOutput($GlobArr['startc'], false, false).'" />');
    if (!$newentry)
      echo('<input type="hidden" name="id" value="'.AMB_DataOutput($GlobArr['id'], false, false).'" />');
    if (!$newentry && $editcom)
      echo('<input type="hidden" name="cid" value="'.AMB_DataOutput($GlobArr['cid'], false, false).'" />');
    echo('<input type="hidden" name="isclosed" value="'.$f_isclosed.'" />');
    
    echo('<table>');
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2051)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_name" value="'.$f_name.'" /></td></tr>');
    if (!$editcom && $CurrentUser->IsInputFieldGen(2, $forcomment)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2053)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_topic" value="'.$f_topic.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(0, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2053)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_email" value="'.$f_email.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(1, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2054)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_homepage" value="'.$f_hp.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(3, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2055)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_icqnum" value="'.$f_icqnum.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(4, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2056)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_msn" value="'.$f_msn.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(5, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2057)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_yahoo" value="'.$f_yahoo.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(6, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2058)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_aim" value="'.$f_aim.'" /></td></tr>');
    }
    if ($CurrentUser->IsInputFieldGen(7, $editcom)) {
      echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2059)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_skype" value="'.$f_skype.'" /></td></tr>');
    }
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(3344)).':&nbsp;</td><td><input type="checkbox" name="new_issticky"'.(($f_issticky) ? ' checked="checked"' : '').' /></td></tr>');
    echo('<tr><td colspan="2">');
    echo(AMB_DataOutput($LangRes->GetRes(2102)).'<br /><br />'.AMB_DataOutput($LangRes->GetRes(2103)).'<br />
    <textarea name="new_input" cols="40" rows="6">'.$f_contents.'</textarea>
    ');
    if (!$editcom) {
      echo('<br /><br />'.AMB_DataOutput($CurrentUser->CommentHeading).'<br />
      <textarea name="new_wmastcomment" cols="40" rows="6">'.$f_wmastcomment.'</textarea></td></tr>');
    }
    echo('</td></tr>
    <tr><td colspan="2"><input'.$buttonclassHTML.' type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3032), true).'" />&nbsp;<input'.$buttonclassHTML.' value="'.AMB_DataOutput($LangRes->GetRes(2105), true).'" type="reset" /></td></tr>
    </table></form>
    ');
  } else {
    if ($editcom) {
      echo('<p>'.$LangRes->GetRes(3034).'</p>');
    } else {
      echo('<p>'.$LangRes->GetRes(3033).'</p>');
    }
  }
}

function admin_del() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  $delcom = (($GlobArr['page'] == 'delco') || ($GlobArr['page'] == 'delcoc'));
  echo('<h1 id="GBTitle">'.(($delcom) ? AMB_DataOutput($LangRes->GetRes(3038)) : AMB_DataOutput($LangRes->GetRes(3037))).'</h1>');
  showmainmenulink();
  if (($GlobArr['action'] == 'delete')) {
    $sql = "DELETE FROM ".($delcom ? 'gbk_comments' : 'gbk')." WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
    if ($delcom) {
      if (isset($GlobArr['cid'])) {
        $sql .= " AND entryid=".sprintf('%d', $GlobArr['id'])." AND comid=".sprintf('%d', $GlobArr['cid']);
      } else {
        $sql .= " AND entryid=".sprintf('%d', $GlobArr['id'])." AND censor=".(($GlobArr['page'] == 'delcoc') ? '1' : '0');
      }
    } else {
      if (isset($GlobArr['id'])) {
        $sql .= " AND entryid=".sprintf('%d', $GlobArr['id']);
      } else {
        $sql .= " AND censor=".(($GlobArr['page'] == 'delc') ? '1' : '0');
      }
    }
    $sqlquery = mysql_query($sql, $MySQLCon);
    if ($sqlquery && (@mysql_affected_rows($MySQLCon) > 0)) {
      if (!$delcom) {
        $sql = "DELETE FROM gbk_comments WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
        $sql .= " AND entryid=".sprintf('%d', $GlobArr['id']);
        mysql_query($sql, $MySQLCon);
      }
      echo('<p>'.(($delcom) ? AMB_DataOutput($LangRes->GetRes(3041)) : AMB_DataOutput($LangRes->GetRes(3039))).'</p>');
    } else {
      echo('<p>'.(($delcom) ? AMB_DataOutput($LangRes->GetRes(3042)) : AMB_DataOutput($LangRes->GetRes(3040))).'</p>');
    }
    echo('<p align="center" class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3113), '', 'page='.$GlobArr['from'].(($delcom) ? '&id='.$GlobArr['id'] : '').createentryparams(), true).'</p>');
  } else {
    if ((!$delcom && isset($GlobArr['id'])) || ($delcom && isset($GlobArr['cid']))) {
      echo('<p>'.(($delcom) ? AMB_DataOutput($LangRes->GetRes(3044)) : AMB_DataOutput($LangRes->GetRes(3043))).'</p>');
    } else {
      echo('<p>'.(($delcom) ? AMB_DataOutput($LangRes->GetRes(3046)) : AMB_DataOutput($LangRes->GetRes(3045))).'</p>');
    }
    $fromlist = (($GlobArr['from'] == 'ent') || ($GlobArr['from'] == 'entc'));
    echo('<p align="center" class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3035), '', 'page='.$GlobArr['page'].((isset($GlobArr['id'])) ? '&id='.$GlobArr['id'] : '').((isset($GlobArr['cid']) && $delcom) ? '&cid='.$GlobArr['cid'] : '').'&action=delete&from='.$GlobArr['from'].createentryparams(), true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3036), '', 'page='.$GlobArr['from'].((!$fromlist) ? '&id='.$GlobArr['id'] : '').createentryparams(), true).'</p>');
  }
}

function admin_rel() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  $relcom = ($GlobArr['page'] == 'relco');
  echo('<h1 id="GBTitle">'.(($relcom) ? AMB_DataOutput($LangRes->GetRes(3048)) : AMB_DataOutput($LangRes->GetRes(3047))).'</h1>');
  showmainmenulink();
  $sql = "UPDATE ".($relcom ? 'gbk_comments' : 'gbk')." SET censor=0 WHERE username='".AMB_SecSQL($CurrentUser->Name)."'";
  if ($relcom) {
    if (isset($GlobArr['cid'])) {
      $sql .= " AND entryid=".sprintf('%d', $GlobArr['id'])." AND comid=".sprintf('%d', $GlobArr['cid']);
    } else {
      $sql .= " AND entryid=".sprintf('%d', $GlobArr['id'])." AND censor=1";
    }
  } else {
    if (isset($GlobArr['id'])) {
      $sql .= " AND entryid=".sprintf('%d', $GlobArr['id']);
    } else {
      $sql .= " AND censor=1";
    }
  }
  $sqlquery = mysql_query($sql, $MySQLCon);
  if ($sqlquery && (@mysql_affected_rows($MySQLCon) > 0)) {
    echo('<p>'.(($relcom) ? AMB_DataOutput($LangRes->GetRes(3051)) : AMB_DataOutput($LangRes->GetRes(3049))).'</p>');
  } else {
    echo('<p>'.(($relcom) ? AMB_DataOutput($LangRes->GetRes(3052)) : AMB_DataOutput($LangRes->GetRes(3050))).'</p>');
  }
  echo('<p align="center" class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3113), '', 'page='.$GlobArr['from'].(($relcom) ? '&id='.$GlobArr['id'] : '').createentryparams(), true).'</p>');
}

function admin_accman() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $Setting;
  // We need the registration resources only here, so import them from inside the function
  AMB_SetLangResource('reg');
  $errmsg = '';
  if (isset($GlobArr['action'])) {
    if ($GlobArr['action'] == 'create') {
      // Create new user
      $GlobArr['uname'] = AMB_CorrectUserName($GlobArr['uname']);
      // Connection was successful, now we can create the new account
      $regres = AMB_RegisterUser($GlobArr['uname'], $GlobArr['upwd'], $GlobArr['upwdrep'], $GlobArr['umail']);
      switch ($regres) {
        case 0:
          // Successful account creation (continue later)
          $errmsg = '<p>'.AMB_DataOutput($LangRes->GetRes(3073, array(1=>$GlobArr['uname']))).'</p>';
          break;
        case 1:
          // User name already exists
          $errmsg = '<p>'.AMB_DataOutput($LangRes->GetRes(3072)).'</p>';
          break;
        case 2:
          // Passwords don't match, let's try it again
          $errmsg = '<p>'.AMB_DataOutput($LangRes->GetRes(3025)).'</p>';
          break;
        case 3:
          // Database query error
          $tempout = AMB_DataOutput($LangRes->GetRes(3026));
          $errmsg = '<p>'.$LangRes->InsertResParams($tempout, array(1=>'<a href="mailto:'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'">'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'</a>')).'</p>';
          break;
      }
    } elseif ($GlobArr['action'] == 'delete') {
      // Try to delete account
      $delres = AMB_DeleteUser($GlobArr['uname']);
      if (!AMB_IsFlag($delres, 2)) {
        // Account deleted successfully
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3074, array(1=>$GlobArr['uname']))).'<br />';
      } else {
        // Account couldn't be deleted
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3075)).'<br />';
      }
      if (!AMB_IsFlag($delres, 0)) {
        // User entries were deleted successfully
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3076)).'<br />';
      } else {
        // User entries couldn't be deleted
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3058)).'<br />';
      }
      if (!AMB_IsFlag($delres, 1)) {
        // User comments were deleted successfully
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3077)).'<br />';
      } else {
        // User comments couldn't be deleted
        $errmsg .= AMB_DataOutput($LangRes->GetRes(3059));
      }
    }
  }
  echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3070)).'</h1>');
  showmainmenulink();
  // Firstly show any error messages
  if ($errmsg != '') {
    echo('<p style="font-weight: bold">'.$errmsg.'</p>');
  }
  // Show form for account creation
  echo('<fieldset style="margin-bottom: 15px; margin-right: auto; margin-left: auto; width: 60%"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3345)).'</legend>');
  showformhead($GlobArr['page'], 'create');
  echo('<table>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(4001)).':</td><td><input type="text" name="uname" size="40" /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(4004)).':</td><td><input type="text" name="umail" size="40" /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(4002)).':</td><td><input type="password" name="upwd" size="40" /></td></tr>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(4003)).':</td><td><input type="password" name="upwdrep" size="40" /></td></tr>
  </table>
  <p style="text-align: center"><input type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3345), true).'" /></p>
  </form>
  </fieldset>');
  
  // Show form for account deletion
  echo('<fieldset style="margin-bottom: 15px; margin-right: auto; margin-left: auto; width: 60%"><legend style="font-weight: bold">'.AMB_DataOutput($LangRes->GetRes(3346)).'</legend>');
  showformhead($GlobArr['page'], 'delete');
  echo('<table>
  <tr><td>'.AMB_DataOutput($LangRes->GetRes(4001)).':</td><td><input type="text" name="uname" size="40" /></td></tr>
  </table>
  <p style="text-align: center"><input type="submit" value="'.AMB_DataOutput($LangRes->GetRes(3346), true).'" /></p>
  </form>
  </fieldset>');
  
}

function admin_lock() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  echo('<h1 id="GBTitle">'.$LangRes->GetRes(3054).'</h1>');
  showmainmenulink();
  $sql = "SELECT flags FROM gbk WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf('%d', $GlobArr['id']);
  $sqlquery = mysql_query($sql, $MySQLCon);
  $sqlqueryerr = !($sqlquery);
  if (!$sqlqueryerr) {
    $sqlobj = mysql_fetch_object($sqlquery);
    $oldflags = sprintf('%d', $sqlobj->flags);
    if (AMB_IsFlag($oldflags, 0)) {
      $oldflags = $oldflags & ~1;
    } else {
      $oldflags = $oldflags | 1;
    }
    $sql = "UPDATE gbk SET flags=$oldflags WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf("%d", $GlobArr['id']);
    $sqlquery = mysql_query($sql, $MySQLCon);
    $sqlqueryerr = !($sqlquery && (@mysql_affected_rows($MySQLCon) > 0));
  }
  if (!$sqlqueryerr) {
    if (AMB_IsFlag($oldflags, 0)) {
      echo('<p>'.$LangRes->GetRes(3055).'</p>');
    } else {
      echo('<p>'.$LangRes->GetRes(3056).'</p>');
    }
  } else {
    echo('<p>'.$LangRes->GetRes(2158).'</p>');
  }
  $from = $GlobArr['from'];
  if (($GlobArr['from'] == 'entco') || ($GlobArr['from'] == 'entcoc')) {
    $from = $from.'&id='.$GlobArr['id'];
  }
  echo('<p align="center" class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3113), '', 'page='.$from.createentryparams(), true).'</p>');
}

function admin_delacc() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $Setting;
  echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3057)).'</h1>');
  showmainmenulink();
  if (($GlobArr['action'] == 'delete')) {
    $entriesrem = true;    
    $result = AMB_DeleteUser($CurrentUser->Name);
    
    if (AMB_IsFlag($result, 0)) {
      // User's entries couldn't be deleted
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(3058)).'</p>');
      $entriesrem = false;
    }
    if (AMB_IsFlag($result, 1)) {
      // User's comments couldn't be deleted
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(3059)).'</p>');
      $entriesrem = false;
    }
    if (AMB_IsFlag($result, 2)) {
      // User's account couldn't be deleted
      $tempoutput = AMB_DataOutput($LangRes->GetRes(3061));
      echo('<p class="InfoLinesClass">'.$LangRes->InsertResParams($tempoutput, array(1=>'<a href="mailto:'.AMB_MaskMailAddress($Setting[CONF_ADMINMAIL]).'">'.AMB_DataOutput($LangRes->GetRes(3062)).'</a>')).'</p>');
    } else {
      // Deleting account was successful
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(3060)).'</p>');
      AMB_session_destroy();
      echo('<p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3114), '', '', true).'</p>');
      if ($Setting[CONF_ACCOUNTMAIL]) mail_accdel($CurrentUser->Name, $entriesrem);
    }
  } else {
    echo('<p>'.AMB_DataOutput($LangRes->GetRes(3063)).'</p>');
    echo('<p align="center" class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3035), '', 'page=delacc&action=delete', true).'&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(3036), '', '', true).'</p>');
  }
}

// Zunchst prfen, ob gerade ein Login stattfand
if (isset($GlobArr['page'])) $addfields['page'] = $GlobArr['page'];
if (isset($GlobArr['action'])) $addfields['action'] = $GlobArr['action'];
if (isset($GlobArr['id'])) $addfields['id'] = $GlobArr['id'];
if (isset($GlobArr['cid'])) $addfields['cid'] = $GlobArr['cid'];
if (isset($GlobArr['from'])) $addfields['from'] = $GlobArr['from'];
if (isset($GlobArr['start'])) $addfields['start'] = $GlobArr['start'];
if (isset($GlobArr['startc'])) $addfields['startc'] = $GlobArr['startc'];
if ((isset($GlobArr['username'])) && (isset($GlobArr['userpwd']))) {
  // Login -> neue Session starten
  if (!AMB_ReadUserInfo($GlobArr['username'], true)) {
    AMB_ShowHTMLHeading();
    echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3064)).'</h1><p>'.AMB_DataOutput($LangRes->GetRes(3065)).'</p><p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3114), '', '').'</p>');
    AMB_ShowHTMLEnding();
    exit();
  }
	if ($CurrentUser->Pwd != md5($GlobArr['userpwd'])) {
    AMB_ShowHTMLHeading();
    echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3064)).'</h1><p>'.AMB_DataOutput($LangRes->GetRes(3066)).'</p><p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3114), '', '').'</p>');
    AMB_ShowHTMLEnding();
    exit();
  }
	
	session_start();
	$_SESSION['UserName'] = $GlobArr['username'];
	$_SESSION['SesTime'] = time();
	$_SESSION['ADR'] = getenv('REMOTE_ADDR');
  AMB_Init($addfields);
} else {
  AMB_Init($addfields);
  if (!AMB_ReadUserInfo($_SESSION['UserName'], true)) {
    // Da ist etwas schief gelaufen -> ausloggen!
    AMB_session_destroy();
    AMB_ShowHTMLHeading();
    echo('<h1 id="GBTitle">'.AMB_DataOutput($LangRes->GetRes(3067)).'</h1><p>'.AMB_DataOutput($LangRes->GetRes(3068)).'</p><p class="InfoLinesClass">'.AMB_CreateLink($LangRes->GetRes(3115)).'</p>');
    AMB_ShowHTMLEnding();
    exit();
  }
}
// Mit der nun vorhandenen Session weiterarbeiten
adminarea();
AMB_mysql_close();

?>