<?php
/*  ------------------------------------------------------------------------
    awzMB Guestbook/Weblog System
    
    Homepage: http://www.awzhome.de/
    ------------------------------------------------------------------------
    
    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

    The Initial Developer of the Original Code is Andreas Weizel.
    Portions created by the Initial Developer are
    Copyright (C) 2001-2007 Andreas Weizel. All Rights Reserved.
    
    Contributor(s):
      Andreas Weizel <webmaster@awzhome.de> (original author)
    
    Alternatively, the contents of this file may be used under the terms
    of the GNU General Public License Version 2.0 or later (the "GPL"),
    or the GNU Lesser General Public License Version 2.1 or later (the
    "LGPL"), in which case the provisions of the GPL or the LGPL are
    applicable instead of those above. If you wish to allow use of your
    version of this file only under the terms of the GPL or the LGPL and
    not to allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and replace
    them with the notice and other provisions required by the GPL or the
    LGPL. If you do not delete the provisions above, a recipient may use
    your version of this file under the terms of any of the MPL, the GPL
    or the LGPL.
    ------------------------------------------------------------------------
*/

global $Setting;

if (!isset($Setting['OPT_includepath'])) $Setting['OPT_includepath'] = '';

include_once($Setting['OPT_includepath'].'awzmb/modules/core/core.incl.php');

AMB_SetLangResource('gbook');

if ($Setting[OPT_CURRENTUSER]) {
  AMB_ReadUserInfo($Setting[OPT_CURRENTUSER]);
} else {
  if (isset($GlobArr['user'])) {
    AMB_ReadUserInfo($GlobArr['user']);
  } else {
    AMB_ReadUserInfo($_SERVER['QUERY_STRING']);
  }

}

AMB_ReadInputCache();
AMB_ReadSeenTopics();

$FieldUnsetErr = false;

function isfieldset($field, $fieldoffset) {
  global $CurrentUser, $GlobArr, $FieldUnsetErr;
  if (isset($GlobArr['eid'])) {
    $isshown = $CurrentUser->IsComInputField($fieldoffset);
  } else {
    $isshown = $CurrentUser->IsInputField($fieldoffset);
  }
  if (!(isset($GlobArr['new_input']) && $isshown && $CurrentUser->IsEssentialField($fieldoffset) && ($field == ''))) {
    return true;
  } else {
    $FieldUnsetErr = true;
    return false;
  }
}

function showinputform($forcomment = false) {
  global $LangRes, $CurrentUser, $UserInputCache, $GlobArr, $Setting;
  global $inputformHTML, $textboxclassHTML, $buttonclassHTML, $infolinesclassHTML;
  echo('<form'.$inputformHTML.' action="'.AMB_GetMyScript().'" method="post">');
  echo('<input type="hidden" name="user" value="'.$CurrentUser->Name.'" />');
  if (isset($GlobArr['eid'])) {
    echo('<input type="hidden" name="eid" value="'.AMB_DataOutput($GlobArr['eid'], true).'" />');
  }
  echo(AMB_CreateCustomParamCode(true));
    
  $FieldUnsetErr = false;
  echo('<table>');
  echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2051)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_name" '.(isset($UserInputCache['name']) ? 'value="'.AMB_DataOutput($UserInputCache['name'], false, false).'"' : '').' /></td></tr>');
  if (!$forcomment && $CurrentUser->IsInputFieldGen(2, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2052)).'&nbsp;</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_topic" /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(0, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2053)).'&nbsp;'.(!isfieldset($GlobArr['new_email'], 0) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_email" '.(isset($UserInputCache['email']) ? 'value="'.AMB_DataOutput($UserInputCache['email'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(1, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2054)).'&nbsp;'.(!isfieldset($GlobArr['new_homepage'], 1) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_homepage" '.(isset($UserInputCache['homepage']) ? 'value="'.AMB_DataOutput($UserInputCache['homepage'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(3, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2055)).'&nbsp;'.(!isfieldset($GlobArr['new_icqnum'], 3) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_icqnum" '.(isset($UserInputCache['icqnum']) ? 'value="'.AMB_DataOutput($UserInputCache['icqnum'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(4, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2056)).'&nbsp;'.(!isfieldset($GlobArr['new_msn'], 4) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_msn" '.(isset($UserInputCache['msn']) ? 'value="'.AMB_DataOutput($UserInputCache['msn'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(5, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2057)).'&nbsp;'.(!isfieldset($GlobArr['new_yahoo'], 5) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_yahoo" '.(isset($UserInputCache['yahoo']) ? 'value="'.AMB_DataOutput($UserInputCache['yahoo'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(6, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2058)).'&nbsp;'.(!isfieldset($GlobArr['new_aim'], 6) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_aim" '.(isset($UserInputCache['aim']) ? 'value="'.AMB_DataOutput($UserInputCache['aim'], false, false).'"' : '').' /></td></tr>');
  }
  if ($CurrentUser->IsInputFieldGen(7, $forcomment)) {
    echo('<tr><td>'.AMB_DataOutput($LangRes->GetRes(2059)).'&nbsp;'.(!isfieldset($GlobArr['new_skype'], 7) ? '<span class="EssWarning">(!)</span>&nbsp;' : '').'</td><td><input'.$textboxclassHTML.' size="25" type="text" name="new_skype" '.(isset($UserInputCache['skype']) ? 'value="'.AMB_DataOutput($UserInputCache['skype'], false, false).'"' : '').' /></td></tr>');
  }
  echo('<tr><td colspan="2">');
  if ($FieldUnsetErr) {
    echo('<span class="EssWarning">(!) - '.AMB_DataOutput($LangRes->GetRes(2101)).'</span><br />');
  }
  echo(AMB_DataOutput($LangRes->GetRes(2102)).'<br /><br />'.AMB_DataOutput($LangRes->GetRes(2103)).'<br />
  <textarea name="new_input" cols="40" rows="6">'.($FieldUnsetErr ? AMB_DataOutput($GlobArr['new_input'], true, false) : '').'</textarea></td></tr>
  <tr><td colspan="2"><input'.$buttonclassHTML.' type="submit" value="'.AMB_DataOutput(($CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) ? $LangRes->GetRes(2106) : $LangRes->GetRes(2104)), true).'" />&nbsp;<input'.$buttonclassHTML.' value="'.AMB_DataOutput($LangRes->GetRes(2105), true).'" type="reset" /></td></tr>
  </table>
  </form>
  ');
  if ($CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
    return;
  
  echo("<p><span$infolinesclassHTML><small>");
  if ($CurrentUser->IsFlag(AMBU_CENSOR)) {
    echo(AMB_DataOutput($LangRes->GetRes(2110)).'<br />');
  }
  if ($CurrentUser->IsFlag(AMBU_ALLOWBBC)) {
    $LangRes->AddRes(2112, AMB_DataOutput($LangRes->GetRes(2112)));
    echo($LangRes->GetRes(2112, array(1=>'<a target="_blank" href="'.$Setting[CONF_HELPSCRIPT].'?user='.$CurrentUser->Name.'&amp;page=bbcodes">'.AMB_DataOutput($LangRes->GetRes(2111)).'</a>')).'<br />');
  }
  if ($CurrentUser->IsFlag(AMBU_USESMILIES)) {
    $LangRes->AddRes(2114, AMB_DataOutput($LangRes->GetRes(2114)));
    echo($LangRes->GetRes(2114, array(1=>'<a target="_blank" href="'.$Setting[CONF_HELPSCRIPT].'?user='.$CurrentUser->Name.'&amp;page=smilies">'.AMB_DataOutput($LangRes->GetRes(2113)).'</a>')).'<br />');
  }
  echo('</small></span></p>');
}

function showentry($sqlobj, $iscomment = false, $comcount = 200) {
  global $LangRes, $CurrentUser, $GlobArr, $Setting;
  global $infolinesclassHTML, $entryheadclassHTML, $entrytopicclassHTML, $entrycontentsclassHTML, $navbarclassHTML;
  
  if ($sqlobj->name == '') {
    $dispname = $LangRes->GetRes(2100);
  } else {
    $dispname = $sqlobj->name;
  }
  $addinfo = '';
  $isfirst = true;
  if ($CurrentUser->IsInputFieldGen(0, $iscomment) && ($sqlobj->email != "")) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="mailto:'.AMB_MaskMailAddress($sqlobj->email).'">'.AMB_DataOutput($LangRes->GetRes(2003)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(1, $iscomment) && ($sqlobj->hp != "")) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="'.AMB_FixWebURL($sqlobj->hp).'">'.AMB_DataOutput($LangRes->GetRes(2004)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(3, $iscomment) && is_numeric($sqlobj->icqnum)) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    if ($CurrentUser->IsFlag(6)) {
      $addinfo .= '<img style="vertical-align: middle;" src="http://wwp.icq.com/scripts/online.dll?icq='.$sqlobj->icqnum.'&amp;img=5" /> ';
    }
    $addinfo .= '<a href="http://wwp.icq.com/'.AMB_DataOutput($sqlobj->icqnum, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2005)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(4, $iscomment) && ($sqlobj->msn != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="http://members.msn.com/'.AMB_DataOutput($sqlobj->msn, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2006)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(5, $iscomment) && ($sqlobj->yahoo != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="http://edit.yahoo.com/config/send_webmesg?.target='.AMB_DataOutput($sqlobj->yahoo, true, false).'">'.AMB_DataOutput($LangRes->GetRes(2007)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(6, $iscomment) && ($sqlobj->aim != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="aim:goim?screenname='.AMB_DataOutput($sqlobj->aim, true, false).'&amp;message=Hallo.+Sind+Sie+online?">'.AMB_DataOutput($LangRes->GetRes(2008)).'</a>';
  }
  if ($CurrentUser->IsInputFieldGen(7, $iscomment) && ($sqlobj->skype != '')) {
    if ($isfirst) $isfirst = false; else $addinfo .= ', ';
    $addinfo .= '<a href="skype:'.AMB_DataOutput($sqlobj->skype, true, false).'?chat">'.AMB_DataOutput($LangRes->GetRes(2009)).'</a>';
  }
  if ($addinfo != '') {
    $addinfo = '('.$addinfo.')';
  }
  // Create head and topic
  $contfileline = '<p><table style="width: 90%; border-style: none">';
  if (!AMB_IsFlag($sqlobj->flags, AMBE_STICKY)) {
    $contfileline .= '<tr><td'.($iscomment ? ' class="EntryComHeadClass"' : $entryheadclassHTML).'><strong>'.AMB_InsertSmilies(AMB_DataOutputEnt($dispname))."</strong> $addinfo&nbsp;&nbsp;&nbsp;<em>".AMB_DecodeDateStamp($sqlobj->datestamp).'</em></td></tr>';
  }
  if (!$iscomment && (($CurrentUser->IsInputField(2)) && ($sqlobj->topic != ''))) {
    $contfileline .= "<tr><td$entrytopicclassHTML>".AMB_InsertSmilies(AMB_FormatFilter(AMB_DataOutput($sqlobj->topic))).'</td></tr>';
  }
  // Entry contents
  $contfileline .= "<tr><td$entrycontentsclassHTML>".AMB_InsertSmilies(AMB_FormatFilter(AMB_DataOutputEnt($sqlobj->contents))).'</td></tr>';
  // Webmaster comment
  if (!$iscomment && ($sqlobj->wmastcomment != '')) {
    $contfileline .= "<tr><td$entrycontentsclassHTML><em><strong>".AMB_InsertSmilies(AMB_DataOutput($CurrentUser->CommentHeading)).'</strong><br />'.AMB_FormatFilter(AMB_DataOutputEnt($sqlobj->wmastcomment, false)).'</em></td></tr>';
  }
  // Comment control elements
  if ($CurrentUser->IsFlag(AMBU_ALLOWCOMMENTS) && !$iscomment) {
    $contfileline .= "<tr><td$navbarclassHTML>".(!AMB_IsFlag($sqlobj->flags, AMBU_CENSOR) ? AMB_CreateLink($LangRes->GetRes(2150), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').'eid='.$sqlobj->entryid.'&action=new') : $LangRes->GetRes(2151)).'&nbsp;&nbsp;'.AMB_CreateLink(($CurrentUser->IsFlag(AMBU_CENSOR) ? $LangRes->GetRes(2152) : $LangRes->GetRes(2153, array(1=>$comcount))), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').'eid='.$sqlobj->entryid).'</td></tr>';
  }
  $contfileline .= '</table></p>';
  echo($contfileline);
}

function showforumentry($sqlobj) {
  global $LangRes, $CurrentUser;
  global $infolinesclassHTML,$entryheadclassHTML,$entrytopicclassHTML,$entrycontentsclassHTML,$navbarclassHTML;
  if ($sqlobj->name == '') {
    $dispname = $LangRes->GetRes(2100);
  } else {
    $dispname = $sqlobj->name;
  }
  if ($sqlobj->topic == '') {
    $disptopic = $LangRes->GetRes(2159);
  } else {
    $disptopic = $sqlobj->topic;
  }
  echo("<table style=\"width: 90%; border-style: none\"><tr><td$entryheadclassHTML>".AMB_CreateLink($disptopic, '', 'user='.$CurrentUser->Name.'&eid='.$sqlobj->entryid).'&nbsp;&nbsp;'.$LangRes->GetRes(2154, array(1=>' &quot;'.AMB_InsertSmilies(AMB_DataOutputEnt($dispname)).'&quot;')).'&nbsp;&nbsp;&nbsp;<em>('.AMB_DecodeDateStamp($sqlobj->newest).')</em>');
  if (AMB_IsTopicNew($sqlobj->entryid, $sqlobj->newest))
    echo('&nbsp;&nbsp;<span style="background-color: #ff0000; color: #ffffff">'.AMB_DataOutput($LangRes->GetRes(2155)).'</span>');
  echo('</td></tr></table>');
}

function write_input() {
  global $MySQLCon, $CurrentUser, $GlobArr, $UserInputCache, $FieldUnsetErr;
  $FieldUnsetErr = false;
  $iscomment = isset($GlobArr['eid']);
  $dontsave = false;
  
  if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
  {
    $dontsave = true;
    
    // Exit if we have to add a comment while it's not allowed
    if ($iscomment)
    {
      if (!$CurrentUser->IsFlag(AMBU_ALLOWCOMMENTS))
        return;
      
      // Check if the topic is locked
      $sql = 'SELECT SQL_CALC_FOUND_ROWS entryid FROM gbk WHERE entryid = '.sprintf('%d', $GlobArr['eid']);
      $sql2 = 'SELECT FOUND_ROWS() AS ecount';
      $sqlquery = mysql_query($sql, $MySQLCon);
      $sqlquery2 = mysql_query($sql2, $MySQLCon);
      $sqlobj = mysql_fetch_object($sqlquery2);
      mysql_free_result($sqlquery2);
      mysql_free_result($sqlquery);
      if (($sqlobj == null) || ($sqlobj->ecount != 1))
      {
        return;
      }
    }
    
    // Fill and save cache array
    $UserInputCache['name'] = $GlobArr['new_name'];
    $UserInputCache['email'] = $GlobArr['new_email'];
    $UserInputCache['homepage'] = $GlobArr['new_homepage'];
    $UserInputCache['icqnum'] = $GlobArr['new_icqnum'];
    $UserInputCache['msn'] = $GlobArr['new_msn'];
    $UserInputCache['yahoo'] = $GlobArr['new_yahoo'];
    $UserInputCache['aim'] = $GlobArr['new_aim'];
    $UserInputCache['skype'] = $GlobArr['new_skype'];
    AMB_SaveInputCache();
    
    // Save entry
    $sqlnames = 'username,datestamp,contents,censor,name'.(!$iscomment ? ',topic' : ',entryid');
    $sqlvals = sprintf("'%s','%s','%s',%d,'%s'", AMB_SecSQL($CurrentUser->Name), AMB_GenDateStamp(),
                        AMB_SecSQL($GlobArr['new_input']), (($CurrentUser->Censoring) ? 1 : 0), AMB_SecSQL($GlobArr['new_name']));
    if (!$iscomment) {
      $sqlvals .= ',\''.AMB_SecSQL($GlobArr['new_topic']).'\'';
    } else {
      $sqlvals .= ','.sprintf('%d', $GlobArr['eid']);
    }                      
    if ($CurrentUser->IsFieldSaved(0, $iscomment)) {
      isfieldset($GlobArr['new_email'], 0);
      $sqlnames .= ',email';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_email']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(1, $iscomment)) {
      isfieldset($GlobArr['new_homepage'], 1);
      $sqlnames .= ',hp';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_homepage']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(3, $iscomment)) {
      isfieldset($GlobArr['new_icqnum'], 3);
      $sqlnames .= ',icqnum';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_icqnum']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(4, $iscomment)) {
      isfieldset($GlobArr['new_msn'], 4);
      $sqlnames .= ',msn';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_msn']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(5, $iscomment)) {
      isfieldset($GlobArr['new_yahoo'], 5);
      $sqlnames .= ',yahoo';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_yahoo']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(6, $iscomment)) {
      isfieldset($GlobArr['new_aim'], 6);
      $sqlnames .= ',aim';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_aim']).'\'';
    }
    if ($CurrentUser->IsFieldSaved(7, $iscomment)) {
      isfieldset($GlobArr['new_skype'], 7);
      $sqlnames .= ',skype';
      $sqlvals .=  ',\''.AMB_SecSQL($GlobArr['new_skype']).'\'';
    }
    if ($FieldUnsetErr) return;
    $sql = sprintf('INSERT INTO '.($iscomment ? 'gbk_comments' : 'gbk').' (%s) VALUES (%s)', $sqlnames, $sqlvals);
    
    mysql_query($sql, $MySQLCon);
    echo(mysql_error($MySQLCon));
    $newentryid = mysql_insert_id($MySQLCon);
  } else {
    $newentryid = 0;
  }
  
  // Notify admin if activated in options
  if ($CurrentUser->MailMe && (!$iscomment || $dontsave)) {
    newentrynotify($newentryid, $GlobArr['new_name'], $GlobArr['new_email'], $GlobArr['new_homepage'], $GlobArr['new_topic'], $GlobArr['new_icqnum'], $GlobArr['new_input'], $CurrentUser->Censoring, $dontsave);
  } elseif ($CurrentUser->IsFlag(13) && $iscomment) {
    newcommentnotify($GlobArr['eid'], $newentryid, $GlobArr['new_name'], $GlobArr['new_email'], $GlobArr['new_homepage'], $GlobArr['new_icqnum'], $GlobArr['new_input'], $CurrentUser->Censoring);
  }
}

function read_file() {
  global $LangRes, $MySQLCon, $CurrentUser, $GlobArr, $Setting, $UserInputCache;
  global $infolinesclassHTML, $entryheadclassHTML, $entrytopicclassHTML, $entrycontentsclassHTML, $navbarclassHTML;
  
  if (!isset($GlobArr['action'])) $GlobArr['action'] = '';
  $singleview = isset($GlobArr['eid']);
  $xinputpage = (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) && $CurrentUser->IsFlag(AMBU_EXTRAINPUTPAGE));
  $createnew = (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES) && ($GlobArr['action'] == 'new'));
  $tablesperpage = $singleview ? $CurrentUser->CommentsPerPage : $CurrentUser->EntriesPerPage;
  // Show input form for new entries
  if ((!$singleview && (!$xinputpage || ($xinputpage && $createnew)) && !$CurrentUser->IsFlag(AMBU_USEASBLOG)) || ($singleview && $createnew)) {
    echo('<p>');
    showinputform($singleview);
    if ($createnew) {
      echo('</p>');
      return;
    } else {
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
        echo('<hr size="1" />');
      echo('</p>');
    }
  } else {
    if (!$singleview && !$CurrentUser->IsFlag(AMBU_USEASBLOG)) {
      echo('<p'.$infolinesclassHTML.'">');
      echo(AMB_CreateLink($LangRes->GetRes(2156), '', 'user='.$CurrentUser->Name.'&action=new'));
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
        echo('<hr size="1" />');
      echo('</p>');
    } elseif ($singleview) {
      echo('<p'.$infolinesclassHTML.'">');
      echo(AMB_CreateLink($LangRes->GetRes(2157), '', 'user='.$CurrentUser->Name));
      if (!$CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
        echo('<hr size="1" />');
      echo('</p>');
    }
  }

  // Don't show entries, if in contact form mode
  if ($CurrentUser->IsFlag(AMBU_DONTSAVEENTRIES))
    return;
  
  if (!isset($GlobArr['start']) || ($GlobArr['start'] < 1)) {
    $e1n = 1;
  } else {
    $e1n = $GlobArr['start'];
  }
  if (!$singleview) {
    $sql = AMB_GetEntrySQLFragment($CurrentUser->Name, false, false, false, true).' LIMIT '.sprintf('%d', $e1n - 1).','.sprintf('%d', $CurrentUser->EntriesPerPage);
    $sqlquery = mysql_query($sql, $MySQLCon);
    // Entry count
    $sql3 = 'SELECT FOUND_ROWS() AS ecount';
    $sqlquery3 = mysql_query($sql3, $MySQLCon);
    $sqlobj3 = mysql_fetch_object($sqlquery3);
    if ($sqlobj3) {
      $gbfilesnum = $sqlobj3->ecount;
    } else {
      $gbfilesnum = 0;
    }
  } else {
    // Zunchst den Haupteintrag anzeigen
    $sql = "SELECT * FROM gbk WHERE username='".AMB_SecSQL($CurrentUser->Name)."' AND entryid=".sprintf('%d', $GlobArr['eid'])." AND censor=0 ORDER BY entryid DESC";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if (!mysql_num_rows($sqlquery) || !($sqlobj = mysql_fetch_object($sqlquery))) {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2158)).'</p>');
      mysql_free_result($sqlquery);
      return;
    }
    mysql_free_result($sqlquery);
    
    if (!$CurrentUser->IsFlag(12)) {
      // If no comments are allowed we have nothing to do anymore
      showentry($sqlobj, false, $gbfilesnum);
      return;
    }
    $sql = "SELECT SQL_CALC_FOUND_ROWS * FROM gbk_comments WHERE entryid=".sprintf('%d', $GlobArr['eid'])." AND censor=0 ORDER BY comid DESC LIMIT ".sprintf('%d', $e1n - 1).','.sprintf('%d', $CurrentUser->CommentsPerPage);
    $sqlquery = mysql_query($sql, $MySQLCon);
    // Entry count
    $sql3 = "SELECT FOUND_ROWS() AS ecount";
    $sqlquery3 = mysql_query($sql3, $MySQLCon);
    $sqlobj3 = mysql_fetch_object($sqlquery3);
    if ($sqlobj3) {
      $gbfilesnum = $sqlobj3->ecount;
    } else {
      $gbfilesnum = 0;
    }
    showentry($sqlobj, false, $gbfilesnum);
    if ($CurrentUser->IsFlag(AMBU_ALLOWCOMMENTS)) {
      echo('<hr size="1" />');
      echo('<h2 id="CommentTitle">'.AMB_DataOutput($LangRes->GetRes(2160)).'</h2>');
    }
  }

  if (!$gbfilesnum) {
    if ($singleview) {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2161)).'</p>');
    } else {
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(2162)).'</p>');
    }
    mysql_free_result($sqlquery);
    return;
  }
  if (!$singleview) {
    echo("<p><span$infolinesclassHTML><small>");
    if ($CurrentUser->IsFlag(7)) {
      echo('<a target="_blank" href="'.$Setting[CONF_RSSSCRIPT].'?'.$CurrentUser->Name.'" title="'.AMB_DataOutput($LangRes->GetRes(2163), true, false).'"><img src="'.$Setting[CONF_PICTUREPATH].'rss.gif" alt="'.AMB_DataOutput($LangRes->GetRes(2163), true, false).'" style="border-style: none" /></a><br /><br />');
    }
    echo('</small></span></p>');
    
    // Let the user choose the display mode (if activated in options)
    if ($CurrentUser->IsFlag(AMBU_USERDISPLAYMODE))
    {
      echo('<p>'.AMB_CreateLink((($UserInputCache['disp'] == '1') ? $LangRes->GetRes(2167) : $LangRes->GetRes(2168)), '', 'disp='.(($UserInputCache['disp'] == '1') ? '0' : '1').(isset($GlobArr['user']) ? '&user='.$GlobArr['user'] : '').(isset($GlobArr['start']) ? '&start='.$GlobArr['start'] : '')).'</p>');
    }
    
  }
  
  if ($gbfilesnum <= ($e1n + $tablesperpage))
  {
    $e2n = $gbfilesnum;
  }
  else
  {
    $e2n = $e1n + $tablesperpage;
  }
  
  if (($e1n <= 1) || ($e1n > $e2n))
  {
    $e1n = 1;
    $firstapproached = true;
  }
  if (($e2n - $e1n) != ($tablesperpage - 1))
  {
    $e2n = $e1n + $tablesperpage - 1;
  }
  if ($e2n >= $gbfilesnum)
  {
    $e2n = $gbfilesnum;
    $lastapproached = true;
  }

  $sqlobj = null;
  while ($sqlobj = mysql_fetch_object($sqlquery))
  {
    if (!$singleview && $CurrentUser->IsFlag(AMBU_FORUMLIKE) && $CurrentUser->IsFlag(AMBU_USERDISPLAYMODE) && ($UserInputCache['disp'] != '1'))
    {
      showforumentry($sqlobj);
    }
    else
    {
      if (!$singleview)
      {
        showentry($sqlobj, false, $sqlobj->comcount);
      }
      else
      {
        showentry($sqlobj, true, $sqlobj3->ecount);
      }
    }
  }
  if ($sqlquery) mysql_free_result($sqlquery);
  if ($sqlquery2) mysql_free_result($sqlquery2);
  if ($sqlquery3) mysql_free_result($sqlquery3);
    
  echo('<p><table><tr><td'.$navbarclassHTML.'>');
  $e1n_next = $e1n + $tablesperpage;
  $e2n_next = $e2n + $tablesperpage;
  $e1n_prev = $e1n - $tablesperpage;
  $e2n_prev = $e2n - $tablesperpage;
  if (!$firstapproached) {
    echo(AMB_CreateLink($LangRes->GetRes(2164, array(1=>$tablesperpage)), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').($singleview ? 'eid='.$GlobArr['eid'].'&' : '')."start=$e1n_prev".(isset($GlobArr['disp']) ? '&disp='.$GlobArr['disp'] : '')).'&nbsp;&nbsp;&nbsp;');
  }
  echo($LangRes->GetRes(2165, array(1=>'<strong>'.$e1n.'</strong>', 2=>'<strong>'.$e2n.'</strong>', 3=>'<strong>'.$gbfilesnum.'</strong>')));
  if (!$lastapproached) {
    //echo("&nbsp;&nbsp;&nbsp;<a href=\"$guestbookdir$mainscript?user=$userfieldname&e1n=$e1n_next&e2n=$e2n_next\">n&auml;chste ".$CurrentUser->EntriesPerPage." &gt;&gt;</a>");
    echo('&nbsp;&nbsp;&nbsp;'.AMB_CreateLink($LangRes->GetRes(2166, array(1=>$tablesperpage)), '', (!$Setting[OPT_NOUSERLINKS] ? 'user='.$CurrentUser->Name.'&' : '').($singleview ? 'eid='.$GlobArr['eid'].'&' : '')."start=$e1n_next".(isset($GlobArr['disp']) ? '&disp='.$GlobArr['disp'] : '')));
  }
  echo('</td></tr></table></p>');  
}

function newentrynotify($entryid, $new_name, $new_mail, $new_hp, $new_topic, $new_icqnum, $new_input, $censoring, $dontsave) {
  global $LangRes, $Setting, $CurrentUser;
  $mailmessage = $LangRes->GetRes(2902, array(1=>AMB_MagicUnQuote($CurrentUser->Name)))."\n\n";
  $mailmessage .= "----------------------------------------------\n";
  $mailmessage .= $LangRes->GetRes(2903)."\n\n";
  $mailmessage .= $LangRes->GetRes(2001).': '.AMB_MagicUnQuote($new_name)."\n";
  if ($CurrentUser->IsComInputField(0) && ($new_mail != '')) {
    $mailmessage .= $LangRes->GetRes(2003).': '.AMB_MagicUnQuote($new_mail)."\n";
  }
  if ($CurrentUser->IsComInputField(1) && ($new_hp != '')) {
    $mailmessage .= $LangRes->GetRes(2004).': '.AMB_MagicUnQuote($new_hp)."\n";
  }
  if ($CurrentUser->IsComInputField(3) && is_numeric($new_icqnum)) {
    $mailmessage .= $LangRes->GetRes(2005).': '.AMB_MagicUnQuote($new_icqnum)."\n";
  }
  $mailmessage .= "----------------------------------------------\n";
  $mailmessage .= $LangRes->GetRes(2904)."\n\n";
  $mailmessage.=AMB_MagicUnQuote($new_input)."\n";
  $mailmessage.="----------------------------------------------\n\n";
  if (!$dontsave && $censoring) {
    $mailmessage .= $LangRes->GetRes(2905)."\n";
    $mailmessage .= $Setting[CONF_ADMINSCRIPT]."?page=rel&id=".$entryid."&from=entc\n";
  }
  $mailmessage .= "\n### ".AMBVERSION."\n### (c) ".AMBCOPYRIGHT;
  // mail input
  @mail($CurrentUser->MailAddress, $LangRes->GetRes(2900), AMB_FixMailLinefeeds($mailmessage), "From: ".$Setting[CONF_MAILFROM]."\r\n"."X-Mailer: ".AMB_GetXMailer());
}

function newcommentnotify($entryid, $comid, $new_name, $new_mail, $new_hp, $new_icqnum, $new_input, $censoring) {
  global $LangRes, $Setting, $CurrentUser;
  $mailmessage = $LangRes->GetRes(2906, array(1=>AMB_MagicUnQuote($CurrentUser->Name), 2=>$Setting[CONF_BOOKSCRIPT]."?user=".AMB_MagicUnQuote($CurrentUser->Name)."&eid=".$entryid))."\n\n";
  $mailmessage .= "----------------------------------------------\n";
  $mailmessage .= $LangRes->GetRes(2903)."\n\n";
  $mailmessage .= $LangRes->GetRes(2001).': '.AMB_MagicUnQuote($new_name)."\n";
  if ($CurrentUser->IsComInputField(0) && ($new_mail != '')) {
    $mailmessage .= $LangRes->GetRes(2003).': '.AMB_MagicUnQuote($new_mail)."\n";
  }
  if ($CurrentUser->IsComInputField(1) && ($new_hp != '')) {
    $mailmessage .= $LangRes->GetRes(2004).': '.AMB_MagicUnQuote($new_hp)."\n";
  }
  if ($CurrentUser->IsComInputField(3) && is_numeric($new_icqnum)) {
    $mailmessage .= $LangRes->GetRes(2005).': '.AMB_MagicUnQuote($new_icqnum)."\n";
  }
  $mailmessage .= "----------------------------------------------\n";
  $mailmessage .= $LangRes->GetRes(2907)."\n\n";
  $mailmessage .= AMB_MagicUnQuote($new_input)."\n";
  $mailmessage .= "----------------------------------------------\n\n";
  if ($censoring) {
  $mailmessage .= $LangRes->GetRes(2908)."\n";
  $mailmessage .= $Setting[CONF_ADMINSCRIPT]."?page=relco&id=".$entryid."&cid=".$comid."&from=entcoc\n";
  }
  $mailmessage.="\n### ".AMBVERSION."\n### (c) ".AMBCOPYRIGHT;
  // mail input
  @mail($CurrentUser->MailAddress, $LangRes->GetRes(2901), AMB_FixMailLinefeeds($mailmessage), "From: ".$Setting[CONF_MAILFROM]."\r\n"."X-Mailer: ".AMB_GetXMailer());
}

if ($MySQLCon) {
  if (isset($GlobArr['new_input']) && ($GlobArr['new_input'] != '') && (!$CurrentUser->UseAsBlog || isset($GlobArr['eid'])))
  {
    write_input();
  }
  
  if (isset($GlobArr['disp']))
  {
    if ($GlobArr['disp'] == '1')
    {
      $UserInputCache['disp'] = '1';
    }
    else
    {
      $UserInputCache['disp'] = '0';
    }
    AMB_SaveInputCache();
  }
  
  AMB_ShowHTMLHeading();

  if (!$CurrentUser->CommentHeading) $CurrentUser->CommentHeading = $LangRes->GetRes(1601);
  
  global $inputformHTML, $textboxclassHTML, $infolinesclassHTML, $entryheadclassHTML, $entrytopicclassHTML, $entrycontentsclassHTML, $navbarclassHTML;
  
  $inputformHTML = " class=\"InputFormClass\"";
  $textboxclassHTML = " class=\"TextBoxClass\"";
  $buttonclassHTML = " class=\"ButtonClass\"";
  $infolinesclassHTML = " class=\"InfoLinesClass\"";
  $entryheadclassHTML = " class=\"EntryHeadClass\"";
  $entrytopicclassHTML = " class=\"EntryTopicClass\"";
  $entrycontentsclassHTML = " class=\"EntryContentsClass\"";
  $navbarclassHTML = " class=\"NavBarClass\"";
  
  if ($CurrentUser->LogoPic != '') {
    echo('<p><img src="'.AMB_DataOutput($CurrentUser->LogoPic, true, false).'" /></p>"');
  }
  
  if ($CurrentUser->GBTitle != '') {
    echo('<h1 id="GBTitle">'.AMB_DataOutput($CurrentUser->GBTitle).'</h1>');
  }
  read_file();
  AMB_mysql_close();
  
  AMB_ShowHTMLEnding();
}

?>