<?php
/*  ------------------------------------------------------------------------
    awzMB Guestbook/Weblog System
    
    Homepage: http://www.awzhome.de/
    ------------------------------------------------------------------------
    
    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

    The Initial Developer of the Original Code is Andreas Weizel.
    Portions created by the Initial Developer are
    Copyright (C) 2001-2007 Andreas Weizel. All Rights Reserved.
    
    Contributor(s):
      Andreas Weizel <webmaster@awzhome.de> (original author)
    
    Alternatively, the contents of this file may be used under the terms
    of the GNU General Public License Version 2.0 or later (the "GPL"),
    or the GNU Lesser General Public License Version 2.1 or later (the
    "LGPL"), in which case the provisions of the GPL or the LGPL are
    applicable instead of those above. If you wish to allow use of your
    version of this file only under the terms of the GPL or the LGPL and
    not to allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and replace
    them with the notice and other provisions required by the GPL or the
    LGPL. If you do not delete the provisions above, a recipient may use
    your version of this file under the terms of any of the MPL, the GPL
    or the LGPL.
    ------------------------------------------------------------------------
*/

include_once('awzmb/modules/core/constants.incl.php');

$Setting[OPT_HTMLBEGIN] = 'commonstyle/instbegin.incl.php';
$Setting[OPT_HTMLEND] = 'commonstyle/commonend.incl.php';
include_once('awzmb/modules/core/core.incl.php');

AMB_SetLangResource('installer');
AMB_SetLangResource('reg');

$maxsteps = 4;

session_start();

if (isset($GlobArr['nextstep'])) {
  $_SESSION['step'] = $GlobArr['nextstep'];
}

if (isset($_SESSION['step'])) {
  $curstep = $_SESSION['step'];
} else {
  $curstep = 1;
}
if ($curstep < 0) $curstep = 0;
if ($curstep > $maxsteps) $curstep = $maxsteps;

function createformhead($nextstep) {
  global $GlobArr;
  $ret = "<form action=\"".AMB_GetMyScript()."\" method=\"post\">\n";
	$ret .= "<input type=\"hidden\" name=\"".session_name()."\" value=\"".session_id()."\" />\n";
  $ret .= "<input type=\"hidden\" name=\"nextstep\" value=\"".sprintf('%d', $nextstep)."\" />\n";
  return $ret;
}

function createnextbutton() {
  global $LangRes;
  return '<input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(5001), true).'" />';
}

function createabortbutton() {
  global $LangRes;
  return '<input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(5005), true).'" />';
}

function create_new_account_form() {
  global $LangRes, $Setting;
  $superadmin = ($Setting[CONF_SUPERADMIN] != '') ? $Setting[CONF_SUPERADMIN] : 'mygb';
  $ret = '<input type="hidden" name="uname" value="'.AMB_DataOutput($superadmin, true).'" />';
  $ret .= '<table>';
  $ret .= '<tr><td><input type="radio" name="createuser" value="0" /></td>';
  $ret .= '<td>'.AMB_DataOutput($LangRes->GetRes(5121)).'</td><td>&nbsp;</td></tr>';
  $ret .= '<tr><td><input type="radio" name="createuser" value="1" checked="checked" /></td>';
  $ret .= '<td>'.AMB_DataOutput($LangRes->GetRes(5122)).'</td><td>&nbsp;</td></tr>';
  $ret .= '<tr><td>&nbsp;</td><td>'.AMB_DataOutput($LangRes->GetRes(5123)).'</td><td><strong>'.AMB_DataOutput($superadmin).'</strong></td></tr>';
  $ret .= '<tr><td>&nbsp;</td><td>'.AMB_DataOutput($LangRes->GetRes(5130)).'</td><td><input type="text" name="umail" size="40" /></td></tr>';
  $ret .= '<tr><td>&nbsp;</td><td>'.AMB_DataOutput($LangRes->GetRes(5124)).'</td><td><input type="password" name="upwd" size="40" /></td></tr>';
  $ret .= '<tr><td>&nbsp;</td><td>'.AMB_DataOutput($LangRes->GetRes(5125)).'</td><td><input type="password" name="upwdrep" size="40" /></td></tr>';
  $ret .= '</table>';
  return $ret;
}

function begincenterleftjustify() {
  echo('<table style="width: 70%"><tr><td style="text-align: left">');
}

function endcenterleftjustify() {
  echo('</td></tr></table>');
}

function createretrybutton() {
  global $LangRes;
  return '<input class="ButtonClass" type="submit" value="'.AMB_DataOutput($LangRes->GetRes(5004), true).'" />';
}

function get_gbk_creation_statement() {
  return "CREATE TABLE gbk (
  entryid bigint(20) unsigned NOT NULL auto_increment,
  username varchar(20) ,
  name varchar(255) ,
  email varchar(255) ,
  hp varchar(255) ,
  datestamp varchar(30) ,
  contents text ,
  wmastcomment text ,
  censor tinyint(2) NOT NULL DEFAULT '0' ,
  topic text ,
  icqnum varchar(20) ,
  flags int(10) unsigned NOT NULL DEFAULT '0' ,
  msn varchar(50) ,
  aim varchar(20) ,
  yahoo varchar(20) ,
  skype varchar(20) ,
  PRIMARY KEY (entryid),
  INDEX user (username),
  INDEX censor (censor)
)";
}

function get_gbk_newcolumn_list() {
  return array('msn',
               'aim',
               'yahoo',
               'skype');
}

function get_gbkcomments_creation_statement() {
  return "CREATE TABLE gbk_comments (
  comid bigint(20) unsigned NOT NULL auto_increment,
  entryid bigint(20) unsigned NOT NULL DEFAULT '0' ,
  username varchar(20) ,
  name varchar(255) ,
  email varchar(255) ,
  hp varchar(255) ,
  datestamp varchar(30) ,
  contents text ,
  censor tinyint(2) NOT NULL DEFAULT '0' ,
  icqnum varchar(20) ,
  PRIMARY KEY (comid),
  INDEX user (username)
)";
}

function get_gbkcomments_newcolumn_list() {
  return array('msn',
               'aim',
               'yahoo',
               'skype');
}

function get_gbkusers_creation_statement() {
  return "CREATE TABLE gbk_users (
  userid bigint(20) unsigned NOT NULL auto_increment,
  username varchar(20) ,
  userpwd text ,
  backgroundpic text ,
  backgroundcolor varchar(20) ,
  linkcolor varchar(20) ,
  textcolor varchar(20) ,
  gbtitle text ,
  gbdesc text ,
  cssfile text ,
  gbtitlecolor varchar(20) ,
  tblcolorhead varchar(20) ,
  tblcolorentry varchar(20) ,
  entriesperpage tinyint(3) unsigned DEFAULT '10' ,
  commentsperpage tinyint(3) unsigned DEFAULT '10' ,
  mailaddress tinytext ,
  logopic text ,
  commenthead text ,
  flags int(10) unsigned NOT NULL DEFAULT '0' ,
  datafields smallint(10) unsigned NOT NULL DEFAULT '0' ,
  datafieldscom smallint(10) unsigned NOT NULL DEFAULT '0' ,
  essfields smallint(10) unsigned NOT NULL DEFAULT '0' ,
  regip varchar(30) ,
  regdt datetime ,
  lang varchar(10) ,
  PRIMARY KEY (userid),
  INDEX usernameindex (username)
)";
}

function get_gbkusers_newcolumn_list() {
  return array('essfields',
               'lang');
}

function inst_introd() {
  global $LangRes;
  // Show introduction
  echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5100)).'</h1>');
  begincenterleftjustify();
  echo('<p><strong>'.AMB_DataOutput($LangRes->GetRes(5101)).'</strong></p>');
  echo('<p>'.AMB_DataOutput($LangRes->GetRes(5102)).'</p>');
  echo('<p><tt>/awzmb/modules/core/settings.incl.php</tt></p>');
  echo('<p>'.AMB_DataOutput($LangRes->GetRes(5103)).'</p>');
  endcenterleftjustify();
  echo('<p>'.createformhead(2).createnextbutton().'</p></form>');
}

function inst_checkdb() {
  global $LangRes, $MySQLCon;
  echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5104)).'</h1>');
  // Create database connection
  $conresult = AMB_mysql_connect(true);
  if ($conresult == 1) {
    // No database server connection
    begincenterleftjustify();
    echo('<p>'.AMB_DataOutput($LangRes->GetRes(5105)).'</p>');
    echo('<p><ul>');
    echo('<li>'.AMB_DataOutput($LangRes->GetRes(5106)).'</li>');
    echo('<li>'.AMB_DataOutput($LangRes->GetRes(5107)).'</li>');
    echo('<li>'.AMB_DataOutput($LangRes->GetRes(5109)).'</li>');
    echo('</ul></p>');
    endcenterleftjustify();
    echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
  } elseif ($conresult == 2) {
    // Couldn't select database
    begincenterleftjustify();
    echo('<p>'.AMB_DataOutput($LangRes->GetRes(5105)).'</p>');
    echo('<p><ul>');
    echo('<li>'.AMB_DataOutput($LangRes->GetRes(5108)).'</li>');
    echo('<li>'.AMB_DataOutput($LangRes->GetRes(5110)).'</li>');
    echo('</ul></p>');
    endcenterleftjustify();
    echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
  } elseif ($conresult == 0) {
    // Get count of existing awzMB tables (if there are any in the database)
    $sql = "SHOW TABLES LIKE 'gbk%'";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if (!$sqlquery) {
      // We seem to have an error
      begincenterleftjustify();
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5105)).'</p>');
      echo('<p><ul>');
      echo('<li>'.AMB_DataOutput($LangRes->GetRes(5117)).'</li>');
      echo('</ul></p>');
      endcenterleftjustify();
      echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
    } else {
      begincenterleftjustify();
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5113)).'</p>');
      echo(createformhead(3));
      // Query was successful, so look if we have found any tables
      if (mysql_num_rows($sqlquery) != 0) {
        // User has to decide, if the found awzMB tables have to be destroyed first
        echo('<p>'.AMB_DataOutput($LangRes->GetRes(5114)).'</p>');
        echo('<table>');
        echo('<tr><td><input type="radio" name="deltables" value="0" checked="checked" /></td>');
        echo('<td>'.AMB_DataOutput($LangRes->GetRes(5115)).'</td></tr>');
        echo('<tr><td><input type="radio" name="deltables" value="1" /></td>');
        echo('<td>'.AMB_DataOutput($LangRes->GetRes(5116)).'</td></tr>');
        echo('</table>');
      }
      endcenterleftjustify();
      echo('<p>'.createnextbutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
    }
  }
  if ($MySQLCon) mysql_close($MySQLCon);
}

function inst_dbtables() {
  global $LangRes, $MySQLCon, $GlobArr;
  // Create database connection
  $conresult = AMB_mysql_connect(true);
  if ($conresult == 0) {
    // Delete old tables if user wants us to do that
    if (isset($GlobArr['deltables']) && ($GlobArr['deltables'] == '1')) {
      $sql = 'DROP TABLE gbk, gbk_comments, gbk_users';
      mysql_query($sql, $MySQLCon);
    }
    // Now run through all awzMB tables and complete all fields missing for the new installation
    $sql = "SHOW TABLES LIKE 'gbk%'";
    $sqlquery = mysql_query($sql, $MySQLCon);
    if ($sqlquery) {
      // Iterate through all found tables
      $gbktables = 0;
      while ($sqlarr = mysql_fetch_row($sqlquery)) {
        switch ($sqlarr[0]) {
          case 'gbk':
            $gbktables = $gbktables | 1;
            $sql2 = 'SHOW COLUMNS FROM gbk';
            $sqlquery2 = mysql_query($sql2, $MySQLCon);
            $newcolumns = get_gbk_newcolumn_list();
            while ($sqlarr2 = @mysql_fetch_row($sqlquery2)) {
              switch ($sqlarr2[0]) {
                case 'msn':
                  unset($newcolumns[0]);
                  break;
                case 'aim':
                  unset($newcolumns[1]);
                  break;
                case 'yahoo':
                  unset($newcolumns[2]);
                  break;
                case 'skype':
                  unset($newcolumns[3]);
                  break;
              }
            }
            // Create missing fields
            $sql3a = '';
            $sql3b = '';
            $sql3c = '';
            $sql3d = '';
            foreach ($newcolumns as $colname) {
              switch ($colname) {
                case 'msn':
                  $sql3a = 'ALTER TABLE gbk ADD msn varchar(50)';
                  break;
                case 'aim':
                  $sql3b = 'ALTER TABLE gbk ADD aim varchar(20)';
                  break;
                case 'yahoo':
                  $sql3c = 'ALTER TABLE gbk ADD yahoo varchar(20)';
                  break;
                case 'skype':
                  $sql3d = 'ALTER TABLE gbk ADD skype varchar(20)';
                  break;
              }
            }
            $sqlresult = true;
            if ($sql3a != '') {
              $sqlpres = mysql_query($sql3a, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3b != '') {
              $sqlpres = mysql_query($sql3b, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3c != '') {
              $sqlpres = mysql_query($sql3c, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3d != '') {
              $sqlpres = mysql_query($sql3d, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if (!$sqlresult) {
              echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
              begincenterleftjustify();
              echo('<p>'.AMB_DataOutput($LangRes->GetRes(5128)).'</p>');
              endcenterleftjustify();
              echo('<p>'.createformhead(3).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
              mysql_close($MySQLCon);
              return;
            }
            break;
          case 'gbk_comments':
            $gbktables = $gbktables | 2;
            $sql2 = 'SHOW COLUMNS FROM gbk_comments';
            $sqlquery2 = mysql_query($sql2, $MySQLCon);
            $newcolumns = get_gbkcomments_newcolumn_list();
            while ($sqlarr2 = @mysql_fetch_row($sqlquery2)) {
              switch ($sqlarr2[0]) {
                case 'msn':
                  unset($newcolumns[0]);
                  break;
                case 'aim':
                  unset($newcolumns[1]);
                  break;
                case 'yahoo':
                  unset($newcolumns[2]);
                  break;
                case 'skype':
                  unset($newcolumns[3]);
                  break;
              }
            }
            // Create missing fields
            $sql3a = '';
            $sql3b = '';
            $sql3c = '';
            $sql3d = '';
            foreach ($newcolumns as $colname) {
              switch ($colname) {
                case 'msn':
                  $sql3a = 'ALTER TABLE gbk_comments ADD msn varchar(50)';
                  break;
                case 'aim':
                  $sql3b = 'ALTER TABLE gbk_comments ADD aim varchar(20)';
                  break;
                case 'yahoo':
                  $sql3c = 'ALTER TABLE gbk_comments ADD yahoo varchar(20)';
                  break;
                case 'skype':
                  $sql3d = 'ALTER TABLE gbk_comments ADD skype varchar(20)';
                  break;
              }
            }
            $sqlresult = true;
            if ($sql3a != '') {
              $sqlpres = mysql_query($sql3a, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3b != '') {
              $sqlpres = mysql_query($sql3b, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3c != '') {
              $sqlpres = mysql_query($sql3c, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3d != '') {
              $sqlpres = mysql_query($sql3d, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if (!$sqlresult) {
              echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
              begincenterleftjustify();
              echo('<p>'.AMB_DataOutput($LangRes->GetRes(5128)).'</p>');
              endcenterleftjustify();
              echo('<p>'.createformhead(3).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
              mysql_close($MySQLCon);
              return;
            }
            break;
          case 'gbk_users':
            $gbktables = $gbktables | 4;
            $sql2 = 'SHOW COLUMNS FROM gbk_users';
            $sqlquery2 = mysql_query($sql2, $MySQLCon);
            $newcolumns = get_gbkusers_newcolumn_list();
            while ($sqlarr2 = @mysql_fetch_row($sqlquery2)) {
              switch ($sqlarr2[0]) {
                case 'essfields':
                  unset($newcolumns[0]);
                  break;
                case 'lang':
                  unset($newcolumns[1]);
                  break;
              }
            }
            // Create missing fields
            $sql3a = '';
            $sql3b = '';
            foreach ($newcolumns as $colname) {
              switch ($colname) {
                case 'essfields':
                  $sql3a = "ALTER TABLE gbk_users ADD essfields smallint(10) unsigned NOT NULL DEFAULT '0' AFTER datafieldscom";
                  break;
                case 'lang':
                  $sql3b = 'ALTER TABLE gbk_users ADD lang varchar(10)';
                  break;
              }
            }
            $sqlresult = true;
            if ($sql3a != '') {
              $sqlpres = mysql_query($sql3a, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if ($sql3b != '') {
              $sqlpres = mysql_query($sql3b, $MySQLCon);
              $sqlresult = $sqlresult && $sqlpres;
            }
            if (!$sqlresult) {
              echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
              begincenterleftjustify();
              echo('<p>'.AMB_DataOutput($LangRes->GetRes(5128)).'</p>');
              endcenterleftjustify();
              echo('<p>'.createformhead(3).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
              mysql_close($MySQLCon);
              return;
            }
            break;
        }
      }
      // Now check which tables are missing and create them
      $sql1a = '';
      $sql1b = '';
      $sql1c = '';
      if (!AMB_IsFlag($gbktables, 0)) {
        // Create gbk table
        $sql1a = get_gbk_creation_statement();
      }
      if (!AMB_IsFlag($gbktables, 1)) {
        // Create gbk_comments table
        $sql1b = get_gbkcomments_creation_statement();
      }
      if (!AMB_IsFlag($gbktables, 2)) {
        // Create gbk_users table
        $sql1c = get_gbkusers_creation_statement();
      }
      // Send SQL creation code
      $sqlresult = true;
      if ($sql1a != '') {
        $sqlresult = $sqlresult && mysql_query($sql1a, $MySQLCon);
      }
      if ($sql1b != '') {
        $sqlresult = $sqlresult && mysql_query($sql1b, $MySQLCon);
      }
      if ($sql1c != '') {
        $sqlresult = $sqlresult && mysql_query($sql1c, $MySQLCon);
      }
      if (!$sqlresult) {
        if (!mysql_query($sql, $MySQLCon)) {
          echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
          begincenterleftjustify();
          echo('<p>'.AMB_DataOutput($LangRes->GetRes(5129)).'</p>');
          endcenterleftjustify();
          echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
          mysql_close($MySQLCon);
          return;
        }
      }
      // Free result
      mysql_free_result($sqlquery);
      
      // Next step: Asking user if he wants to create a new account
      echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5118)).'</h1>');
      begincenterleftjustify();
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5119)).'</p>');
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5120)).'</p>');
      echo(createformhead(4));
      echo(create_new_account_form());
      endcenterleftjustify();
      echo('<p>'.createnextbutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
    } else {
      // Listing awzMB tables was not successful
      echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
      begincenterleftjustify();
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5126)).'</p>');
      endcenterleftjustify();
      echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
    }
  } else {
    // Connection couldn't be established
    echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
    begincenterleftjustify();
    echo('<p>'.AMB_DataOutput($LangRes->GetRes(5127)).'</p>');
    endcenterleftjustify();
    echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
  }
  if ($MySQLCon) mysql_close($MySQLCon);
}

function inst_createuser() {
  global $LangRes, $MySQLCon, $GlobArr, $Setting;
  if (isset($GlobArr['createuser']) && ($GlobArr['createuser'] == '1')) {
    // Create database connection
    $conresult = AMB_mysql_connect(true);
    if ($conresult == 0) {
      // Connection was successful, now we can create the new account
      $GlobArr['uname'] = AMB_CorrectUserName($GlobArr['uname']);
      $regres = AMB_RegisterUser($GlobArr['uname'], $GlobArr['upwd'], $GlobArr['upwdrep'], $GlobArr['umail']);
      switch ($regres) {
        case 0:
        case 1:
          // Successful account creation (continue later)
          break;
        case 2:
          // Passwords don't match, let's try it again
          echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
          echo('<p>'.AMB_DataOutput($LangRes->GetRes(5131)).'</p>');
          begincenterleftjustify();
          echo(createformhead(4));
          echo(create_new_account_form());
          endcenterleftjustify();
          echo('<p>'.createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
          return;
        case 3:
          // Database query error
          echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
          echo('<p>'.AMB_DataOutput($LangRes->GetRes(5136)).'</p>');
          begincenterleftjustify();
          echo(createformhead(4));
          echo(create_new_account_form());
          endcenterleftjustify();
          echo('<p>'.createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
          return;
      }
    } else {
      // Connection failed
      echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5006)).'</h1>');
      begincenterleftjustify();
      echo('<p>'.AMB_DataOutput($LangRes->GetRes(5127)).'</p>');
      endcenterleftjustify();
      echo('<p>'.createformhead(2).createretrybutton().'</p></form><p>'.createformhead(0).createabortbutton().'</form></p>');
      return;
    }
  }
  
  // We're at the end of installation!
  $_SESSION = array();
  session_destroy();
  echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5132)).'</h1>');
  begincenterleftjustify();
  $tempout = AMB_DataOutput($LangRes->GetRes(5133));
  echo('<p>'.$LangRes->InsertResParams($tempout, array(1=>'<a href="'.AMB_DataOutput($Setting[CONF_ADMINSCRIPT], true).'">'.AMB_DataOutput($LangRes->GetRes(5134)).'</a>')).'</p>');
  echo('<p><span style="color: #ff0000">'.AMB_DataOutput($LangRes->GetRes(5137)).'</span></p>');
  echo('<p><strong>'.AMB_DataOutput($LangRes->GetRes(5135)).'</strong></p>');
  endcenterleftjustify();
}

function inst_abort() {
  global $LangRes;
  // Create page shown on installation abort
  echo('<h1 class="GBTitle">'.AMB_DataOutput($LangRes->GetRes(5111)).'</h1>');
  begincenterleftjustify();
  echo('<p>'.AMB_DataOutput($LangRes->GetRes(5112)).'</p>');
  endcenterleftjustify();
}

switch ($curstep) {
  case 1:
    AMB_ShowHTMLHeading();
    inst_introd();
    AMB_ShowHTMLEnding();
    break;
  case 2:
    AMB_ShowHTMLHeading();
    inst_checkdb();
    AMB_ShowHTMLEnding();
    break;
  case 3:
    AMB_ShowHTMLHeading();
    inst_dbtables();
    AMB_ShowHTMLEnding();
    break;
  case 4:
    AMB_ShowHTMLHeading();
    inst_createuser();
    AMB_ShowHTMLEnding();
    break;
  case 0:
    // Destroy session on installation abort
    $_SESSION = array();
    session_destroy();
    
    AMB_ShowHTMLHeading();
    inst_abort();
    AMB_ShowHTMLEnding();
    break;
}

?>