/*  ------------------------------------------------------------------------
    awzMB Guestbook/Weblog System
    
    Homepage: http://www.awzhome.de/
    ------------------------------------------------------------------------
    
    The contents of this file are subject to the Mozilla Public License
    Version 1.1 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at
    http://www.mozilla.org/MPL/
    
    Software distributed under the License is distributed on an "AS IS"
    basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
    License for the specific language governing rights and limitations
    under the License.

    The Initial Developer of the Original Code is Andreas Weizel.
    Portions created by the Initial Developer are
    Copyright (C) 2001-2006 Andreas Weizel. All Rights Reserved.
    
    Contributor(s):
      Andreas Weizel <webmaster@awzhome.de> (original author)
    
    Alternatively, the contents of this file may be used under the terms
    of the GNU General Public License Version 2.0 or later (the "GPL"),
    or the GNU Lesser General Public License Version 2.1 or later (the
    "LGPL"), in which case the provisions of the GPL or the LGPL are
    applicable instead of those above. If you wish to allow use of your
    version of this file only under the terms of the GPL or the LGPL and
    not to allow others to use your version of this file under the MPL,
    indicate your decision by deleting the provisions above and replace
    them with the notice and other provisions required by the GPL or the
    LGPL. If you do not delete the provisions above, a recipient may use
    your version of this file under the terms of any of the MPL, the GPL
    or the LGPL.
    ------------------------------------------------------------------------
*/

var pickerVisible = false;

function ColorHover(col, inputfield) {
  document.getElementById(inputfield + "Button").style.backgroundColor = col;
}

function SelectColor(col, inputfield) {
  document.getElementById(inputfield).value = col;
  ClosePicker(inputfield);
}

function DrawRaisedBorder(obj) {
  obj.style.border = "1px solid #808080";
  obj.style.backgroundColor = "#FFE5B3";
}

function DrawSunkenBorder(obj) {
  obj.style.border = "1px solid #808080";
  obj.style.backgroundColor = "#FE914E";
}

function DrawNoBorder(obj) {
  obj.style.border = "1px solid #e0e0e0";
  obj.style.backgroundColor = "#e0e0e0";
}

function ShowPicker(inputfield) {
  if (pickerVisible) {
    ClosePicker(inputfield);
    return;
  }
  var obj = document.getElementById(inputfield + "Button");
  var picker = document.getElementById(inputfield + "Layer");
  picker.style.visibility = "visible";
  picker.style.top = (GetPickerY(obj) + obj.offsetHeight) + "px";
  picker.style.left = GetPickerX(obj) + "px";
  picker.style.width = "150px";
  pickerVisible = true;
}

function ClosePicker(inputfield) {
  var picker = document.getElementById(inputfield + "Layer");
  picker.style.visibility = "hidden";
  pickerVisible = false;
  UpdatePicker(inputfield);
}

function UpdatePicker(inputfield) {
  try {
    document.getElementById(inputfield + "Button").style.backgroundColor = document.getElementById(inputfield).value;
  } catch (e) {
    // do nothing
  }
}

function GetPickerX(obj) {
  xpos = 0;
  while (obj != null) {
    xpos += obj.offsetLeft;
    obj = obj.offsetParent;
  }
  return xpos;
}

function GetPickerY(obj) {
  ypos = 0;
  while (obj != null) {
    ypos += obj.offsetTop;
    obj = obj.offsetParent;
  }
  return ypos;
}

function CreatePicker(forId) {
  var output = "<img id=\"" + forId + "Button\" src=\"" + pickerPath + "picker.gif\" style=\"width: 40px; height: 20px; vertical-align: bottom; background-color: " + document.getElementById(forId).value + "\" onclick=\"ShowPicker('" + forId + "');\" alt=\"" + altText + "\" />";
  output += "<div id=\"" + forId + "Layer\" style=\"visibility: hidden; position: absolute; border: 1px solid #808080; padding: 2px; background-color: #e0e0e0\">";
  output += "<div style=\"text-align: right\"><img style=\"border: 1px solid #e0e0e0; width: 14px; height: 13px\" onmouseover=\"DrawRaisedBorder(this);\" onmouseout=\"DrawNoBorder(this)\" onmousedown=\"DrawSunkenBorder(this);\" onmouseup=\"DrawRaisedBorder(this); ClosePicker('" + forId + "');\" src=\"" + pickerPath + "closer.gif\" alt=\"X\" /></div>";
  output += "<table style=\"border-style: none\">";
  output += "<tr>";
  output += "<td onclick=\"SelectColor('#ff0000', '" + forId + "');\" onmouseover=\"ColorHover('#ff0000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff0000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#400000', '" + forId + "');\" onmouseover=\"ColorHover('#400000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #400000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#800000', '" + forId + "');\" onmouseover=\"ColorHover('#800000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #800000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c00000', '" + forId + "');\" onmouseover=\"ColorHover('#c00000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c00000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ff4040', '" + forId + "');\" onmouseover=\"ColorHover('#ff4040', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff4040\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ff8080', '" + forId + "');\" onmouseover=\"ColorHover('#ff8080', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff8080\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffc0c0', '" + forId + "');\" onmouseover=\"ColorHover('#ffc0c0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffc0c0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#000000', '" + forId + "');\" onmouseover=\"ColorHover('#000000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #000000\">&nbsp;</td>";
  output += "</tr><tr>";
  output += "<td onclick=\"SelectColor('#ffff00', '" + forId + "');\" onmouseover=\"ColorHover('#ffff00', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffff00\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#404000', '" + forId + "');\" onmouseover=\"ColorHover('#404000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #404000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#808000', '" + forId + "');\" onmouseover=\"ColorHover('#808000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #808000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c0c000', '" + forId + "');\" onmouseover=\"ColorHover('#c0c000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c0c000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffff40', '" + forId + "');\" onmouseover=\"ColorHover('#ffff40', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffff40\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffff80', '" + forId + "');\" onmouseover=\"ColorHover('#ffff80', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffff80\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffffc0', '" + forId + "');\" onmouseover=\"ColorHover('#ffffc0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffffc0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#202020', '" + forId + "');\" onmouseover=\"ColorHover('#202020', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #202020\">&nbsp;</td>";
  output += "</tr><tr>";
  output += "<td onclick=\"SelectColor('#00ff00', '" + forId + "');\" onmouseover=\"ColorHover('#00ff00', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #00ff00\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#004000', '" + forId + "');\" onmouseover=\"ColorHover('#004000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #004000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#008000', '" + forId + "');\" onmouseover=\"ColorHover('#008000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #008000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#00c000', '" + forId + "');\" onmouseover=\"ColorHover('#00c000', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #00c000\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#40ff40', '" + forId + "');\" onmouseover=\"ColorHover('#40ff40', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #40ff40\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#80ff80', '" + forId + "');\" onmouseover=\"ColorHover('#80ff80', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #80ff80\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c0ffc0', '" + forId + "');\" onmouseover=\"ColorHover('#c0ffc0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c0ffc0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#404040', '" + forId + "');\" onmouseover=\"ColorHover('#404040', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #404040\">&nbsp;</td>";
  output += "</tr><tr>";
  output += "<td onclick=\"SelectColor('#00ffff', '" + forId + "');\" onmouseover=\"ColorHover('#00ffff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #00ffff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#004040', '" + forId + "');\" onmouseover=\"ColorHover('#004040', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #004040\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#008080', '" + forId + "');\" onmouseover=\"ColorHover('#008080', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #008080\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#00c0c0', '" + forId + "');\" onmouseover=\"ColorHover('#00c0c0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #00c0c0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#40ffff', '" + forId + "');\" onmouseover=\"ColorHover('#40ffff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #40ffff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#80ffff', '" + forId + "');\" onmouseover=\"ColorHover('#80ffff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #80ffff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c0ffff', '" + forId + "');\" onmouseover=\"ColorHover('#c0ffff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c0ffff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#808080', '" + forId + "');\" onmouseover=\"ColorHover('#808080', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #808080\">&nbsp;</td>";
  output += "</tr><tr>";
  output += "<td onclick=\"SelectColor('#0000ff', '" + forId + "');\" onmouseover=\"ColorHover('#0000ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #0000ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#000040', '" + forId + "');\" onmouseover=\"ColorHover('#000040', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #000040\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#000080', '" + forId + "');\" onmouseover=\"ColorHover('#000080', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #000080\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#0000c0', '" + forId + "');\" onmouseover=\"ColorHover('#0000c0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #0000c0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#4040ff', '" + forId + "');\" onmouseover=\"ColorHover('#4040ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #4040ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#8080ff', '" + forId + "');\" onmouseover=\"ColorHover('#8080ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #8080ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c0c0ff', '" + forId + "');\" onmouseover=\"ColorHover('#c0c0ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c0c0ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c0c0c0', '" + forId + "');\" onmouseover=\"ColorHover('#c0c0c0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c0c0c0\">&nbsp;</td>";
  output += "</tr><tr>";
  output += "<td onclick=\"SelectColor('#ff00ff', '" + forId + "');\" onmouseover=\"ColorHover('#ff00ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff00ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#400040', '" + forId + "');\" onmouseover=\"ColorHover('#400040', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #400040\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#800080', '" + forId + "');\" onmouseover=\"ColorHover('#800080', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #800080\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#c000c0', '" + forId + "');\" onmouseover=\"ColorHover('#c000c0', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #c000c0\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ff40ff', '" + forId + "');\" onmouseover=\"ColorHover('#ff40ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff40ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ff80ff', '" + forId + "');\" onmouseover=\"ColorHover('#ff80ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ff80ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffc0ff', '" + forId + "');\" onmouseover=\"ColorHover('#ffc0ff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffc0ff\">&nbsp;</td>";
  output += "<td onclick=\"SelectColor('#ffffff', '" + forId + "');\" onmouseover=\"ColorHover('#ffffff', '" + forId + "');\" style=\"height: 14px; width: 14px; background-color: #ffffff\">&nbsp;</td>";
  output += "</tr></table></div>";
  document.write(output);
}
